"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var audio_stream_exports = {};
__export(audio_stream_exports, {
  AudioStream: () => AudioStream
});
module.exports = __toCommonJS(audio_stream_exports);
var import_web = require("node:stream/web");
var import_audio_frame = require("./audio_frame.cjs");
var import_ffi_client = require("./ffi_client.cjs");
var import_audio_frame_pb = require("./proto/audio_frame_pb.cjs");
class AudioStreamSource {
  constructor(track, sampleRateOrOptions, numChannels) {
    this.onEvent = (ev) => {
      if (!this.controller) {
        throw new Error("Stream controller not initialized");
      }
      if (ev.message.case != "audioStreamEvent" || ev.message.value.streamHandle != this.ffiHandle.handle) {
        return;
      }
      const streamEvent = ev.message.value.message;
      switch (streamEvent.case) {
        case "frameReceived":
          const frame = import_audio_frame.AudioFrame.fromOwnedInfo(streamEvent.value.frame);
          this.controller.enqueue(frame);
          break;
        case "eos":
          import_ffi_client.FfiClient.instance.off(import_ffi_client.FfiClientEvent.FfiEvent, this.onEvent);
          this.controller.close();
          break;
      }
    };
    if (sampleRateOrOptions !== void 0 && typeof sampleRateOrOptions !== "number") {
      this.sampleRate = sampleRateOrOptions.sampleRate ?? 48e3;
      this.numChannels = sampleRateOrOptions.numChannels ?? 1;
      this.ncOptions = sampleRateOrOptions.noiseCancellation;
    } else {
      this.sampleRate = sampleRateOrOptions ?? 48e3;
      this.numChannels = numChannels ?? 1;
    }
    const req = new import_audio_frame_pb.NewAudioStreamRequest({
      type: import_audio_frame_pb.AudioStreamType.AUDIO_STREAM_NATIVE,
      trackHandle: track.ffi_handle.handle,
      sampleRate: this.sampleRate,
      numChannels: this.numChannels,
      ...this.ncOptions ? {
        audioFilterModuleId: this.ncOptions.moduleId,
        audioFilterOptions: JSON.stringify(this.ncOptions.options)
      } : {}
    });
    const res = import_ffi_client.FfiClient.instance.request({
      message: {
        case: "newAudioStream",
        value: req
      }
    });
    this.ffiHandle = new import_ffi_client.FfiHandle(res.stream.handle.id);
    import_ffi_client.FfiClient.instance.on(import_ffi_client.FfiClientEvent.FfiEvent, this.onEvent);
  }
  start(controller) {
    this.controller = controller;
  }
  cancel() {
    import_ffi_client.FfiClient.instance.off(import_ffi_client.FfiClientEvent.FfiEvent, this.onEvent);
    this.ffiHandle.dispose();
  }
}
class AudioStream extends import_web.ReadableStream {
  constructor(track, sampleRateOrOptions, numChannels) {
    super(new AudioStreamSource(track, sampleRateOrOptions, numChannels));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AudioStream
});
//# sourceMappingURL=audio_stream.cjs.map