import { Message, PartialMessage, proto2, FieldList, BinaryReadOptions, JsonValue, JsonReadOptions, PlainMessage } from '@bufbuild/protobuf';
import { FfiOwnedHandle } from './handle_pb.js';

/**
 * @generated from enum livekit.proto.ParticipantKind
 */
declare enum ParticipantKind {
    /**
     * @generated from enum value: PARTICIPANT_KIND_STANDARD = 0;
     */
    STANDARD = 0,
    /**
     * @generated from enum value: PARTICIPANT_KIND_INGRESS = 1;
     */
    INGRESS = 1,
    /**
     * @generated from enum value: PARTICIPANT_KIND_EGRESS = 2;
     */
    EGRESS = 2,
    /**
     * @generated from enum value: PARTICIPANT_KIND_SIP = 3;
     */
    SIP = 3,
    /**
     * @generated from enum value: PARTICIPANT_KIND_AGENT = 4;
     */
    AGENT = 4
}
/**
 * @generated from enum livekit.proto.DisconnectReason
 */
declare enum DisconnectReason {
    /**
     * @generated from enum value: UNKNOWN_REASON = 0;
     */
    UNKNOWN_REASON = 0,
    /**
     * the client initiated the disconnect
     *
     * @generated from enum value: CLIENT_INITIATED = 1;
     */
    CLIENT_INITIATED = 1,
    /**
     * another participant with the same identity has joined the room
     *
     * @generated from enum value: DUPLICATE_IDENTITY = 2;
     */
    DUPLICATE_IDENTITY = 2,
    /**
     * the server instance is shutting down
     *
     * @generated from enum value: SERVER_SHUTDOWN = 3;
     */
    SERVER_SHUTDOWN = 3,
    /**
     * RoomService.RemoveParticipant was called
     *
     * @generated from enum value: PARTICIPANT_REMOVED = 4;
     */
    PARTICIPANT_REMOVED = 4,
    /**
     * RoomService.DeleteRoom was called
     *
     * @generated from enum value: ROOM_DELETED = 5;
     */
    ROOM_DELETED = 5,
    /**
     * the client is attempting to resume a session, but server is not aware of it
     *
     * @generated from enum value: STATE_MISMATCH = 6;
     */
    STATE_MISMATCH = 6,
    /**
     * client was unable to connect fully
     *
     * @generated from enum value: JOIN_FAILURE = 7;
     */
    JOIN_FAILURE = 7,
    /**
     * Cloud-only, the server requested Participant to migrate the connection elsewhere
     *
     * @generated from enum value: MIGRATION = 8;
     */
    MIGRATION = 8,
    /**
     * the signal websocket was closed unexpectedly
     *
     * @generated from enum value: SIGNAL_CLOSE = 9;
     */
    SIGNAL_CLOSE = 9,
    /**
     * the room was closed, due to all Standard and Ingress participants having left
     *
     * @generated from enum value: ROOM_CLOSED = 10;
     */
    ROOM_CLOSED = 10,
    /**
     * SIP callee did not respond in time
     *
     * @generated from enum value: USER_UNAVAILABLE = 11;
     */
    USER_UNAVAILABLE = 11,
    /**
     * SIP callee rejected the call (busy)
     *
     * @generated from enum value: USER_REJECTED = 12;
     */
    USER_REJECTED = 12,
    /**
     * SIP protocol failure or unexpected response
     *
     * @generated from enum value: SIP_TRUNK_FAILURE = 13;
     */
    SIP_TRUNK_FAILURE = 13
}
/**
 * @generated from message livekit.proto.ParticipantInfo
 */
declare class ParticipantInfo extends Message<ParticipantInfo> {
    /**
     * @generated from field: required string sid = 1;
     */
    sid?: string;
    /**
     * @generated from field: required string name = 2;
     */
    name?: string;
    /**
     * @generated from field: required string identity = 3;
     */
    identity?: string;
    /**
     * @generated from field: required string metadata = 4;
     */
    metadata?: string;
    /**
     * @generated from field: map<string, string> attributes = 5;
     */
    attributes: {
        [key: string]: string;
    };
    /**
     * @generated from field: required livekit.proto.ParticipantKind kind = 6;
     */
    kind?: ParticipantKind;
    /**
     * @generated from field: required livekit.proto.DisconnectReason disconnect_reason = 7;
     */
    disconnectReason?: DisconnectReason;
    constructor(data?: PartialMessage<ParticipantInfo>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.ParticipantInfo";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantInfo;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantInfo;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantInfo;
    static equals(a: ParticipantInfo | PlainMessage<ParticipantInfo> | undefined, b: ParticipantInfo | PlainMessage<ParticipantInfo> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.OwnedParticipant
 */
declare class OwnedParticipant extends Message<OwnedParticipant> {
    /**
     * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
     */
    handle?: FfiOwnedHandle;
    /**
     * @generated from field: required livekit.proto.ParticipantInfo info = 2;
     */
    info?: ParticipantInfo;
    constructor(data?: PartialMessage<OwnedParticipant>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.OwnedParticipant";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedParticipant;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedParticipant;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedParticipant;
    static equals(a: OwnedParticipant | PlainMessage<OwnedParticipant> | undefined, b: OwnedParticipant | PlainMessage<OwnedParticipant> | undefined): boolean;
}

export { DisconnectReason, OwnedParticipant, ParticipantInfo, ParticipantKind };
