import { Message, PartialMessage, proto2, FieldList, BinaryReadOptions, JsonValue, JsonReadOptions, PlainMessage } from '@bufbuild/protobuf';

/**
 * @generated from message livekit.proto.RpcError
 */
declare class RpcError extends Message<RpcError> {
    /**
     * @generated from field: required uint32 code = 1;
     */
    code?: number;
    /**
     * @generated from field: required string message = 2;
     */
    message?: string;
    /**
     * @generated from field: optional string data = 3;
     */
    data?: string;
    constructor(data?: PartialMessage<RpcError>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RpcError";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RpcError;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RpcError;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RpcError;
    static equals(a: RpcError | PlainMessage<RpcError> | undefined, b: RpcError | PlainMessage<RpcError> | undefined): boolean;
}
/**
 * FFI Requests
 *
 * @generated from message livekit.proto.PerformRpcRequest
 */
declare class PerformRpcRequest extends Message<PerformRpcRequest> {
    /**
     * @generated from field: required uint64 local_participant_handle = 1;
     */
    localParticipantHandle?: bigint;
    /**
     * @generated from field: required string destination_identity = 2;
     */
    destinationIdentity?: string;
    /**
     * @generated from field: required string method = 3;
     */
    method?: string;
    /**
     * @generated from field: required string payload = 4;
     */
    payload?: string;
    /**
     * @generated from field: optional uint32 response_timeout_ms = 5;
     */
    responseTimeoutMs?: number;
    constructor(data?: PartialMessage<PerformRpcRequest>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.PerformRpcRequest";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PerformRpcRequest;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PerformRpcRequest;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PerformRpcRequest;
    static equals(a: PerformRpcRequest | PlainMessage<PerformRpcRequest> | undefined, b: PerformRpcRequest | PlainMessage<PerformRpcRequest> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.RegisterRpcMethodRequest
 */
declare class RegisterRpcMethodRequest extends Message<RegisterRpcMethodRequest> {
    /**
     * @generated from field: required uint64 local_participant_handle = 1;
     */
    localParticipantHandle?: bigint;
    /**
     * @generated from field: required string method = 2;
     */
    method?: string;
    constructor(data?: PartialMessage<RegisterRpcMethodRequest>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RegisterRpcMethodRequest";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RegisterRpcMethodRequest;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RegisterRpcMethodRequest;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RegisterRpcMethodRequest;
    static equals(a: RegisterRpcMethodRequest | PlainMessage<RegisterRpcMethodRequest> | undefined, b: RegisterRpcMethodRequest | PlainMessage<RegisterRpcMethodRequest> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.UnregisterRpcMethodRequest
 */
declare class UnregisterRpcMethodRequest extends Message<UnregisterRpcMethodRequest> {
    /**
     * @generated from field: required uint64 local_participant_handle = 1;
     */
    localParticipantHandle?: bigint;
    /**
     * @generated from field: required string method = 2;
     */
    method?: string;
    constructor(data?: PartialMessage<UnregisterRpcMethodRequest>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.UnregisterRpcMethodRequest";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UnregisterRpcMethodRequest;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UnregisterRpcMethodRequest;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UnregisterRpcMethodRequest;
    static equals(a: UnregisterRpcMethodRequest | PlainMessage<UnregisterRpcMethodRequest> | undefined, b: UnregisterRpcMethodRequest | PlainMessage<UnregisterRpcMethodRequest> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.RpcMethodInvocationResponseRequest
 */
declare class RpcMethodInvocationResponseRequest extends Message<RpcMethodInvocationResponseRequest> {
    /**
     * @generated from field: required uint64 local_participant_handle = 1;
     */
    localParticipantHandle?: bigint;
    /**
     * @generated from field: required uint64 invocation_id = 2;
     */
    invocationId?: bigint;
    /**
     * @generated from field: optional string payload = 3;
     */
    payload?: string;
    /**
     * @generated from field: optional livekit.proto.RpcError error = 4;
     */
    error?: RpcError;
    constructor(data?: PartialMessage<RpcMethodInvocationResponseRequest>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RpcMethodInvocationResponseRequest";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RpcMethodInvocationResponseRequest;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RpcMethodInvocationResponseRequest;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RpcMethodInvocationResponseRequest;
    static equals(a: RpcMethodInvocationResponseRequest | PlainMessage<RpcMethodInvocationResponseRequest> | undefined, b: RpcMethodInvocationResponseRequest | PlainMessage<RpcMethodInvocationResponseRequest> | undefined): boolean;
}
/**
 * FFI Responses
 *
 * @generated from message livekit.proto.PerformRpcResponse
 */
declare class PerformRpcResponse extends Message<PerformRpcResponse> {
    /**
     * @generated from field: required uint64 async_id = 1;
     */
    asyncId?: bigint;
    constructor(data?: PartialMessage<PerformRpcResponse>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.PerformRpcResponse";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PerformRpcResponse;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PerformRpcResponse;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PerformRpcResponse;
    static equals(a: PerformRpcResponse | PlainMessage<PerformRpcResponse> | undefined, b: PerformRpcResponse | PlainMessage<PerformRpcResponse> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.RegisterRpcMethodResponse
 */
declare class RegisterRpcMethodResponse extends Message<RegisterRpcMethodResponse> {
    constructor(data?: PartialMessage<RegisterRpcMethodResponse>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RegisterRpcMethodResponse";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RegisterRpcMethodResponse;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RegisterRpcMethodResponse;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RegisterRpcMethodResponse;
    static equals(a: RegisterRpcMethodResponse | PlainMessage<RegisterRpcMethodResponse> | undefined, b: RegisterRpcMethodResponse | PlainMessage<RegisterRpcMethodResponse> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.UnregisterRpcMethodResponse
 */
declare class UnregisterRpcMethodResponse extends Message<UnregisterRpcMethodResponse> {
    constructor(data?: PartialMessage<UnregisterRpcMethodResponse>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.UnregisterRpcMethodResponse";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UnregisterRpcMethodResponse;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UnregisterRpcMethodResponse;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UnregisterRpcMethodResponse;
    static equals(a: UnregisterRpcMethodResponse | PlainMessage<UnregisterRpcMethodResponse> | undefined, b: UnregisterRpcMethodResponse | PlainMessage<UnregisterRpcMethodResponse> | undefined): boolean;
}
/**
 * @generated from message livekit.proto.RpcMethodInvocationResponseResponse
 */
declare class RpcMethodInvocationResponseResponse extends Message<RpcMethodInvocationResponseResponse> {
    /**
     * @generated from field: optional string error = 1;
     */
    error?: string;
    constructor(data?: PartialMessage<RpcMethodInvocationResponseResponse>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RpcMethodInvocationResponseResponse";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RpcMethodInvocationResponseResponse;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RpcMethodInvocationResponseResponse;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RpcMethodInvocationResponseResponse;
    static equals(a: RpcMethodInvocationResponseResponse | PlainMessage<RpcMethodInvocationResponseResponse> | undefined, b: RpcMethodInvocationResponseResponse | PlainMessage<RpcMethodInvocationResponseResponse> | undefined): boolean;
}
/**
 * FFI Callbacks
 *
 * @generated from message livekit.proto.PerformRpcCallback
 */
declare class PerformRpcCallback extends Message<PerformRpcCallback> {
    /**
     * @generated from field: required uint64 async_id = 1;
     */
    asyncId?: bigint;
    /**
     * @generated from field: optional string payload = 2;
     */
    payload?: string;
    /**
     * @generated from field: optional livekit.proto.RpcError error = 3;
     */
    error?: RpcError;
    constructor(data?: PartialMessage<PerformRpcCallback>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.PerformRpcCallback";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PerformRpcCallback;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PerformRpcCallback;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PerformRpcCallback;
    static equals(a: PerformRpcCallback | PlainMessage<PerformRpcCallback> | undefined, b: PerformRpcCallback | PlainMessage<PerformRpcCallback> | undefined): boolean;
}
/**
 * FFI Events
 *
 * @generated from message livekit.proto.RpcMethodInvocationEvent
 */
declare class RpcMethodInvocationEvent extends Message<RpcMethodInvocationEvent> {
    /**
     * @generated from field: required uint64 local_participant_handle = 1;
     */
    localParticipantHandle?: bigint;
    /**
     * @generated from field: required uint64 invocation_id = 2;
     */
    invocationId?: bigint;
    /**
     * @generated from field: required string method = 3;
     */
    method?: string;
    /**
     * @generated from field: required string request_id = 4;
     */
    requestId?: string;
    /**
     * @generated from field: required string caller_identity = 5;
     */
    callerIdentity?: string;
    /**
     * @generated from field: required string payload = 6;
     */
    payload?: string;
    /**
     * @generated from field: required uint32 response_timeout_ms = 7;
     */
    responseTimeoutMs?: number;
    constructor(data?: PartialMessage<RpcMethodInvocationEvent>);
    static readonly runtime: typeof proto2;
    static readonly typeName = "livekit.proto.RpcMethodInvocationEvent";
    static readonly fields: FieldList;
    static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RpcMethodInvocationEvent;
    static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RpcMethodInvocationEvent;
    static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RpcMethodInvocationEvent;
    static equals(a: RpcMethodInvocationEvent | PlainMessage<RpcMethodInvocationEvent> | undefined, b: RpcMethodInvocationEvent | PlainMessage<RpcMethodInvocationEvent> | undefined): boolean;
}

export { PerformRpcCallback, PerformRpcRequest, PerformRpcResponse, RegisterRpcMethodRequest, RegisterRpcMethodResponse, RpcError, RpcMethodInvocationEvent, RpcMethodInvocationResponseRequest, RpcMethodInvocationResponseResponse, UnregisterRpcMethodRequest, UnregisterRpcMethodResponse };
