import { FfiClient, FfiHandle } from "./ffi_client.js";
import { CreateAudioTrackRequest, CreateVideoTrackRequest } from "./proto/track_pb.js";
class Track {
  constructor(owned) {
    this.info = owned.info;
    this.ffi_handle = new FfiHandle(owned.handle.id);
  }
  get sid() {
    var _a;
    return (_a = this.info) == null ? void 0 : _a.sid;
  }
  get name() {
    var _a;
    return (_a = this.info) == null ? void 0 : _a.name;
  }
  get kind() {
    var _a;
    return (_a = this.info) == null ? void 0 : _a.kind;
  }
  get stream_state() {
    var _a;
    return (_a = this.info) == null ? void 0 : _a.streamState;
  }
  get muted() {
    var _a;
    return (_a = this.info) == null ? void 0 : _a.muted;
  }
}
class LocalAudioTrack extends Track {
  constructor(owned) {
    super(owned);
  }
  static createAudioTrack(name, source) {
    const req = new CreateAudioTrackRequest({
      name,
      sourceHandle: source.ffiHandle.handle
    });
    const res = FfiClient.instance.request({
      message: { case: "createAudioTrack", value: req }
    });
    return new LocalAudioTrack(res.track);
  }
}
class LocalVideoTrack extends Track {
  constructor(owned) {
    super(owned);
  }
  static createVideoTrack(name, source) {
    const req = new CreateVideoTrackRequest({
      name,
      sourceHandle: source.ffiHandle.handle
    });
    const res = FfiClient.instance.request({
      message: { case: "createVideoTrack", value: req }
    });
    return new LocalVideoTrack(res.track);
  }
}
class RemoteVideoTrack extends Track {
  constructor(owned) {
    super(owned);
  }
}
class RemoteAudioTrack extends Track {
  constructor(owned) {
    super(owned);
  }
}
export {
  LocalAudioTrack,
  LocalVideoTrack,
  RemoteAudioTrack,
  RemoteVideoTrack,
  Track
};
//# sourceMappingURL=track.js.map