import { VideoBufferType, VideoBufferInfo, OwnedVideoBuffer } from './proto/video_frame_pb.js';
import '@bufbuild/protobuf';
import './proto/track_pb.js';
import './proto/stats_pb.js';
import './proto/e2ee_pb.js';
import './proto/handle_pb.js';

declare class VideoFrame {
    data: Uint8Array;
    width: number;
    height: number;
    type: VideoBufferType;
    constructor(data: Uint8Array, width: number, height: number, type: VideoBufferType);
    /** @internal */
    get dataPtr(): bigint;
    /** @internal */
    protoInfo(): VideoBufferInfo;
    /** @internal */
    static fromOwnedInfo(owned: OwnedVideoBuffer): VideoFrame;
    getPlane(planeNth: number): Uint8Array | void;
    convert(dstType: VideoBufferType, flipY?: boolean): VideoFrame;
}

export { VideoFrame };
