import './ffi_client.cjs';
import { VideoSourceInfo, VideoRotation } from './proto/video_frame_pb.cjs';
import { VideoFrame } from './video_frame.cjs';
import { FfiHandle } from './napi/native.d.cjs';
import '@bufbuild/protobuf';
import '@livekit/typed-emitter';
import './proto/ffi_pb.cjs';
import './proto/room_pb.cjs';
import './proto/participant_pb.cjs';
import './proto/handle_pb.cjs';
import './proto/track_pb.cjs';
import './proto/stats_pb.cjs';
import './proto/e2ee_pb.cjs';
import './proto/audio_frame_pb.cjs';
import './proto/rpc_pb.cjs';
import './proto/track_publication_pb.cjs';

declare class VideoSource {
    /** @internal */
    info?: VideoSourceInfo;
    /** @internal */
    ffiHandle: FfiHandle;
    /** @internal */
    closed: boolean;
    width: number;
    height: number;
    constructor(width: number, height: number);
    captureFrame(frame: VideoFrame, timestampUs?: bigint, rotation?: VideoRotation): void;
    close(): Promise<void>;
}

export { VideoSource };
