import { ReadableStream } from 'node:stream/web';
import { VideoRotation } from './proto/video_frame_pb.js';
import { Track } from './track.js';
import { VideoFrame } from './video_frame.js';
import '@bufbuild/protobuf';
import './proto/track_pb.js';
import './proto/stats_pb.js';
import './proto/e2ee_pb.js';
import './proto/handle_pb.js';
import './audio_source.js';
import './audio_frame.js';
import './proto/audio_frame_pb.js';
import './napi/native.d.js';
import './ffi_client.js';
import '@livekit/typed-emitter';
import './proto/ffi_pb.js';
import './proto/room_pb.js';
import './proto/participant_pb.js';
import './proto/rpc_pb.js';
import './proto/track_publication_pb.js';
import './video_source.js';

type VideoFrameEvent = {
    frame: VideoFrame;
    timestampUs: bigint;
    rotation: VideoRotation;
};
declare class VideoStream extends ReadableStream<VideoFrameEvent> {
    constructor(track: Track);
}

export { type VideoFrameEvent, VideoStream };
