// Copyright 2023 LiveKit, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.10.0 with parameter "target=ts,import_extension=.js"
// @generated from file audio_frame.proto (package livekit.proto, syntax proto2)
/* eslint-disable */
// @ts-nocheck

import type { BinaryReadOptions, FieldList, JsonReadOptions, JsonValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto2 } from "@bufbuild/protobuf";
import { TrackSource } from "./track_pb.js";
import { FfiOwnedHandle } from "./handle_pb.js";

/**
 * @generated from enum livekit.proto.SoxResamplerDataType
 */
export enum SoxResamplerDataType {
  /**
   * TODO(theomonnom): support other datatypes (shouldn't really be needed)
   *
   * @generated from enum value: SOXR_DATATYPE_INT16I = 0;
   */
  SOXR_DATATYPE_INT16I = 0,

  /**
   * @generated from enum value: SOXR_DATATYPE_INT16S = 1;
   */
  SOXR_DATATYPE_INT16S = 1,
}
// Retrieve enum metadata with: proto2.getEnumType(SoxResamplerDataType)
proto2.util.setEnumType(SoxResamplerDataType, "livekit.proto.SoxResamplerDataType", [
  { no: 0, name: "SOXR_DATATYPE_INT16I" },
  { no: 1, name: "SOXR_DATATYPE_INT16S" },
]);

/**
 * @generated from enum livekit.proto.SoxQualityRecipe
 */
export enum SoxQualityRecipe {
  /**
   * @generated from enum value: SOXR_QUALITY_QUICK = 0;
   */
  SOXR_QUALITY_QUICK = 0,

  /**
   * @generated from enum value: SOXR_QUALITY_LOW = 1;
   */
  SOXR_QUALITY_LOW = 1,

  /**
   * @generated from enum value: SOXR_QUALITY_MEDIUM = 2;
   */
  SOXR_QUALITY_MEDIUM = 2,

  /**
   * @generated from enum value: SOXR_QUALITY_HIGH = 3;
   */
  SOXR_QUALITY_HIGH = 3,

  /**
   * @generated from enum value: SOXR_QUALITY_VERYHIGH = 4;
   */
  SOXR_QUALITY_VERYHIGH = 4,
}
// Retrieve enum metadata with: proto2.getEnumType(SoxQualityRecipe)
proto2.util.setEnumType(SoxQualityRecipe, "livekit.proto.SoxQualityRecipe", [
  { no: 0, name: "SOXR_QUALITY_QUICK" },
  { no: 1, name: "SOXR_QUALITY_LOW" },
  { no: 2, name: "SOXR_QUALITY_MEDIUM" },
  { no: 3, name: "SOXR_QUALITY_HIGH" },
  { no: 4, name: "SOXR_QUALITY_VERYHIGH" },
]);

/**
 * @generated from enum livekit.proto.SoxFlagBits
 */
export enum SoxFlagBits {
  /**
   * 1 << 0
   *
   * @generated from enum value: SOXR_ROLLOFF_SMALL = 0;
   */
  SOXR_ROLLOFF_SMALL = 0,

  /**
   * 1 << 1
   *
   * @generated from enum value: SOXR_ROLLOFF_MEDIUM = 1;
   */
  SOXR_ROLLOFF_MEDIUM = 1,

  /**
   * 1 << 2
   *
   * @generated from enum value: SOXR_ROLLOFF_NONE = 2;
   */
  SOXR_ROLLOFF_NONE = 2,

  /**
   * 1 << 3
   *
   * @generated from enum value: SOXR_HIGH_PREC_CLOCK = 3;
   */
  SOXR_HIGH_PREC_CLOCK = 3,

  /**
   * 1 << 4
   *
   * @generated from enum value: SOXR_DOUBLE_PRECISION = 4;
   */
  SOXR_DOUBLE_PRECISION = 4,

  /**
   * 1 << 5
   *
   * @generated from enum value: SOXR_VR = 5;
   */
  SOXR_VR = 5,
}
// Retrieve enum metadata with: proto2.getEnumType(SoxFlagBits)
proto2.util.setEnumType(SoxFlagBits, "livekit.proto.SoxFlagBits", [
  { no: 0, name: "SOXR_ROLLOFF_SMALL" },
  { no: 1, name: "SOXR_ROLLOFF_MEDIUM" },
  { no: 2, name: "SOXR_ROLLOFF_NONE" },
  { no: 3, name: "SOXR_HIGH_PREC_CLOCK" },
  { no: 4, name: "SOXR_DOUBLE_PRECISION" },
  { no: 5, name: "SOXR_VR" },
]);

/**
 * @generated from enum livekit.proto.AudioStreamType
 */
export enum AudioStreamType {
  /**
   * @generated from enum value: AUDIO_STREAM_NATIVE = 0;
   */
  AUDIO_STREAM_NATIVE = 0,

  /**
   * @generated from enum value: AUDIO_STREAM_HTML = 1;
   */
  AUDIO_STREAM_HTML = 1,
}
// Retrieve enum metadata with: proto2.getEnumType(AudioStreamType)
proto2.util.setEnumType(AudioStreamType, "livekit.proto.AudioStreamType", [
  { no: 0, name: "AUDIO_STREAM_NATIVE" },
  { no: 1, name: "AUDIO_STREAM_HTML" },
]);

/**
 * @generated from enum livekit.proto.AudioSourceType
 */
export enum AudioSourceType {
  /**
   * @generated from enum value: AUDIO_SOURCE_NATIVE = 0;
   */
  AUDIO_SOURCE_NATIVE = 0,
}
// Retrieve enum metadata with: proto2.getEnumType(AudioSourceType)
proto2.util.setEnumType(AudioSourceType, "livekit.proto.AudioSourceType", [
  { no: 0, name: "AUDIO_SOURCE_NATIVE" },
]);

/**
 * Create a new AudioStream
 * AudioStream is used to receive audio frames from a track
 *
 * @generated from message livekit.proto.NewAudioStreamRequest
 */
export class NewAudioStreamRequest extends Message<NewAudioStreamRequest> {
  /**
   * @generated from field: required uint64 track_handle = 1;
   */
  trackHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.AudioStreamType type = 2;
   */
  type?: AudioStreamType;

  /**
   * @generated from field: optional uint32 sample_rate = 3;
   */
  sampleRate?: number;

  /**
   * @generated from field: optional uint32 num_channels = 4;
   */
  numChannels?: number;

  /**
   * Unique identifier passed in LoadAudioFilterPluginRequest
   *
   * @generated from field: optional string audio_filter_module_id = 5;
   */
  audioFilterModuleId?: string;

  /**
   * @generated from field: optional string audio_filter_options = 6;
   */
  audioFilterOptions?: string;

  constructor(data?: PartialMessage<NewAudioStreamRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioStreamRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "track_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "type", kind: "enum", T: proto2.getEnumType(AudioStreamType), req: true },
    { no: 3, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
    { no: 4, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
    { no: 5, name: "audio_filter_module_id", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 6, name: "audio_filter_options", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioStreamRequest {
    return new NewAudioStreamRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioStreamRequest {
    return new NewAudioStreamRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioStreamRequest {
    return new NewAudioStreamRequest().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioStreamRequest | PlainMessage<NewAudioStreamRequest> | undefined, b: NewAudioStreamRequest | PlainMessage<NewAudioStreamRequest> | undefined): boolean {
    return proto2.util.equals(NewAudioStreamRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewAudioStreamResponse
 */
export class NewAudioStreamResponse extends Message<NewAudioStreamResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioStream stream = 1;
   */
  stream?: OwnedAudioStream;

  constructor(data?: PartialMessage<NewAudioStreamResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioStreamResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream", kind: "message", T: OwnedAudioStream, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioStreamResponse {
    return new NewAudioStreamResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioStreamResponse {
    return new NewAudioStreamResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioStreamResponse {
    return new NewAudioStreamResponse().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioStreamResponse | PlainMessage<NewAudioStreamResponse> | undefined, b: NewAudioStreamResponse | PlainMessage<NewAudioStreamResponse> | undefined): boolean {
    return proto2.util.equals(NewAudioStreamResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioStreamFromParticipantRequest
 */
export class AudioStreamFromParticipantRequest extends Message<AudioStreamFromParticipantRequest> {
  /**
   * @generated from field: required uint64 participant_handle = 1;
   */
  participantHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.AudioStreamType type = 2;
   */
  type?: AudioStreamType;

  /**
   * @generated from field: optional livekit.proto.TrackSource track_source = 3;
   */
  trackSource?: TrackSource;

  /**
   * @generated from field: optional uint32 sample_rate = 5;
   */
  sampleRate?: number;

  /**
   * @generated from field: optional uint32 num_channels = 6;
   */
  numChannels?: number;

  /**
   * @generated from field: optional string audio_filter_module_id = 7;
   */
  audioFilterModuleId?: string;

  /**
   * @generated from field: optional string audio_filter_options = 8;
   */
  audioFilterOptions?: string;

  constructor(data?: PartialMessage<AudioStreamFromParticipantRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioStreamFromParticipantRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "type", kind: "enum", T: proto2.getEnumType(AudioStreamType), req: true },
    { no: 3, name: "track_source", kind: "enum", T: proto2.getEnumType(TrackSource), opt: true },
    { no: 5, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
    { no: 6, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
    { no: 7, name: "audio_filter_module_id", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 8, name: "audio_filter_options", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioStreamFromParticipantRequest {
    return new AudioStreamFromParticipantRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioStreamFromParticipantRequest {
    return new AudioStreamFromParticipantRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioStreamFromParticipantRequest {
    return new AudioStreamFromParticipantRequest().fromJsonString(jsonString, options);
  }

  static equals(a: AudioStreamFromParticipantRequest | PlainMessage<AudioStreamFromParticipantRequest> | undefined, b: AudioStreamFromParticipantRequest | PlainMessage<AudioStreamFromParticipantRequest> | undefined): boolean {
    return proto2.util.equals(AudioStreamFromParticipantRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioStreamFromParticipantResponse
 */
export class AudioStreamFromParticipantResponse extends Message<AudioStreamFromParticipantResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioStream stream = 1;
   */
  stream?: OwnedAudioStream;

  constructor(data?: PartialMessage<AudioStreamFromParticipantResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioStreamFromParticipantResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream", kind: "message", T: OwnedAudioStream, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioStreamFromParticipantResponse {
    return new AudioStreamFromParticipantResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioStreamFromParticipantResponse {
    return new AudioStreamFromParticipantResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioStreamFromParticipantResponse {
    return new AudioStreamFromParticipantResponse().fromJsonString(jsonString, options);
  }

  static equals(a: AudioStreamFromParticipantResponse | PlainMessage<AudioStreamFromParticipantResponse> | undefined, b: AudioStreamFromParticipantResponse | PlainMessage<AudioStreamFromParticipantResponse> | undefined): boolean {
    return proto2.util.equals(AudioStreamFromParticipantResponse, a, b);
  }
}

/**
 * Create a new AudioSource
 *
 * @generated from message livekit.proto.NewAudioSourceRequest
 */
export class NewAudioSourceRequest extends Message<NewAudioSourceRequest> {
  /**
   * @generated from field: required livekit.proto.AudioSourceType type = 1;
   */
  type?: AudioSourceType;

  /**
   * @generated from field: optional livekit.proto.AudioSourceOptions options = 2;
   */
  options?: AudioSourceOptions;

  /**
   * @generated from field: required uint32 sample_rate = 3;
   */
  sampleRate?: number;

  /**
   * @generated from field: required uint32 num_channels = 4;
   */
  numChannels?: number;

  /**
   * @generated from field: optional uint32 queue_size_ms = 5;
   */
  queueSizeMs?: number;

  constructor(data?: PartialMessage<NewAudioSourceRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioSourceRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "type", kind: "enum", T: proto2.getEnumType(AudioSourceType), req: true },
    { no: 2, name: "options", kind: "message", T: AudioSourceOptions, opt: true },
    { no: 3, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 5, name: "queue_size_ms", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioSourceRequest {
    return new NewAudioSourceRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioSourceRequest {
    return new NewAudioSourceRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioSourceRequest {
    return new NewAudioSourceRequest().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioSourceRequest | PlainMessage<NewAudioSourceRequest> | undefined, b: NewAudioSourceRequest | PlainMessage<NewAudioSourceRequest> | undefined): boolean {
    return proto2.util.equals(NewAudioSourceRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewAudioSourceResponse
 */
export class NewAudioSourceResponse extends Message<NewAudioSourceResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioSource source = 1;
   */
  source?: OwnedAudioSource;

  constructor(data?: PartialMessage<NewAudioSourceResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioSourceResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "source", kind: "message", T: OwnedAudioSource, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioSourceResponse {
    return new NewAudioSourceResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioSourceResponse {
    return new NewAudioSourceResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioSourceResponse {
    return new NewAudioSourceResponse().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioSourceResponse | PlainMessage<NewAudioSourceResponse> | undefined, b: NewAudioSourceResponse | PlainMessage<NewAudioSourceResponse> | undefined): boolean {
    return proto2.util.equals(NewAudioSourceResponse, a, b);
  }
}

/**
 * Push a frame to an AudioSource 
 * The data provided must be available as long as the client receive the callback.
 *
 * @generated from message livekit.proto.CaptureAudioFrameRequest
 */
export class CaptureAudioFrameRequest extends Message<CaptureAudioFrameRequest> {
  /**
   * @generated from field: required uint64 source_handle = 1;
   */
  sourceHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.AudioFrameBufferInfo buffer = 2;
   */
  buffer?: AudioFrameBufferInfo;

  constructor(data?: PartialMessage<CaptureAudioFrameRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.CaptureAudioFrameRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "source_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "buffer", kind: "message", T: AudioFrameBufferInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): CaptureAudioFrameRequest {
    return new CaptureAudioFrameRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): CaptureAudioFrameRequest {
    return new CaptureAudioFrameRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): CaptureAudioFrameRequest {
    return new CaptureAudioFrameRequest().fromJsonString(jsonString, options);
  }

  static equals(a: CaptureAudioFrameRequest | PlainMessage<CaptureAudioFrameRequest> | undefined, b: CaptureAudioFrameRequest | PlainMessage<CaptureAudioFrameRequest> | undefined): boolean {
    return proto2.util.equals(CaptureAudioFrameRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.CaptureAudioFrameResponse
 */
export class CaptureAudioFrameResponse extends Message<CaptureAudioFrameResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<CaptureAudioFrameResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.CaptureAudioFrameResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): CaptureAudioFrameResponse {
    return new CaptureAudioFrameResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): CaptureAudioFrameResponse {
    return new CaptureAudioFrameResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): CaptureAudioFrameResponse {
    return new CaptureAudioFrameResponse().fromJsonString(jsonString, options);
  }

  static equals(a: CaptureAudioFrameResponse | PlainMessage<CaptureAudioFrameResponse> | undefined, b: CaptureAudioFrameResponse | PlainMessage<CaptureAudioFrameResponse> | undefined): boolean {
    return proto2.util.equals(CaptureAudioFrameResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.CaptureAudioFrameCallback
 */
export class CaptureAudioFrameCallback extends Message<CaptureAudioFrameCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<CaptureAudioFrameCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.CaptureAudioFrameCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): CaptureAudioFrameCallback {
    return new CaptureAudioFrameCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): CaptureAudioFrameCallback {
    return new CaptureAudioFrameCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): CaptureAudioFrameCallback {
    return new CaptureAudioFrameCallback().fromJsonString(jsonString, options);
  }

  static equals(a: CaptureAudioFrameCallback | PlainMessage<CaptureAudioFrameCallback> | undefined, b: CaptureAudioFrameCallback | PlainMessage<CaptureAudioFrameCallback> | undefined): boolean {
    return proto2.util.equals(CaptureAudioFrameCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.ClearAudioBufferRequest
 */
export class ClearAudioBufferRequest extends Message<ClearAudioBufferRequest> {
  /**
   * @generated from field: required uint64 source_handle = 1;
   */
  sourceHandle?: bigint;

  constructor(data?: PartialMessage<ClearAudioBufferRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ClearAudioBufferRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "source_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ClearAudioBufferRequest {
    return new ClearAudioBufferRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ClearAudioBufferRequest {
    return new ClearAudioBufferRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ClearAudioBufferRequest {
    return new ClearAudioBufferRequest().fromJsonString(jsonString, options);
  }

  static equals(a: ClearAudioBufferRequest | PlainMessage<ClearAudioBufferRequest> | undefined, b: ClearAudioBufferRequest | PlainMessage<ClearAudioBufferRequest> | undefined): boolean {
    return proto2.util.equals(ClearAudioBufferRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.ClearAudioBufferResponse
 */
export class ClearAudioBufferResponse extends Message<ClearAudioBufferResponse> {
  constructor(data?: PartialMessage<ClearAudioBufferResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ClearAudioBufferResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ClearAudioBufferResponse {
    return new ClearAudioBufferResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ClearAudioBufferResponse {
    return new ClearAudioBufferResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ClearAudioBufferResponse {
    return new ClearAudioBufferResponse().fromJsonString(jsonString, options);
  }

  static equals(a: ClearAudioBufferResponse | PlainMessage<ClearAudioBufferResponse> | undefined, b: ClearAudioBufferResponse | PlainMessage<ClearAudioBufferResponse> | undefined): boolean {
    return proto2.util.equals(ClearAudioBufferResponse, a, b);
  }
}

/**
 * Create a new AudioResampler
 *
 * @generated from message livekit.proto.NewAudioResamplerRequest
 */
export class NewAudioResamplerRequest extends Message<NewAudioResamplerRequest> {
  constructor(data?: PartialMessage<NewAudioResamplerRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioResamplerRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioResamplerRequest {
    return new NewAudioResamplerRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioResamplerRequest {
    return new NewAudioResamplerRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioResamplerRequest {
    return new NewAudioResamplerRequest().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioResamplerRequest | PlainMessage<NewAudioResamplerRequest> | undefined, b: NewAudioResamplerRequest | PlainMessage<NewAudioResamplerRequest> | undefined): boolean {
    return proto2.util.equals(NewAudioResamplerRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewAudioResamplerResponse
 */
export class NewAudioResamplerResponse extends Message<NewAudioResamplerResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioResampler resampler = 1;
   */
  resampler?: OwnedAudioResampler;

  constructor(data?: PartialMessage<NewAudioResamplerResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewAudioResamplerResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "resampler", kind: "message", T: OwnedAudioResampler, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewAudioResamplerResponse {
    return new NewAudioResamplerResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewAudioResamplerResponse {
    return new NewAudioResamplerResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewAudioResamplerResponse {
    return new NewAudioResamplerResponse().fromJsonString(jsonString, options);
  }

  static equals(a: NewAudioResamplerResponse | PlainMessage<NewAudioResamplerResponse> | undefined, b: NewAudioResamplerResponse | PlainMessage<NewAudioResamplerResponse> | undefined): boolean {
    return proto2.util.equals(NewAudioResamplerResponse, a, b);
  }
}

/**
 * Remix and resample an audio frame
 *
 * @generated from message livekit.proto.RemixAndResampleRequest
 */
export class RemixAndResampleRequest extends Message<RemixAndResampleRequest> {
  /**
   * @generated from field: required uint64 resampler_handle = 1;
   */
  resamplerHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.AudioFrameBufferInfo buffer = 2;
   */
  buffer?: AudioFrameBufferInfo;

  /**
   * @generated from field: required uint32 num_channels = 3;
   */
  numChannels?: number;

  /**
   * @generated from field: required uint32 sample_rate = 4;
   */
  sampleRate?: number;

  constructor(data?: PartialMessage<RemixAndResampleRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RemixAndResampleRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "resampler_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "buffer", kind: "message", T: AudioFrameBufferInfo, req: true },
    { no: 3, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RemixAndResampleRequest {
    return new RemixAndResampleRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RemixAndResampleRequest {
    return new RemixAndResampleRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RemixAndResampleRequest {
    return new RemixAndResampleRequest().fromJsonString(jsonString, options);
  }

  static equals(a: RemixAndResampleRequest | PlainMessage<RemixAndResampleRequest> | undefined, b: RemixAndResampleRequest | PlainMessage<RemixAndResampleRequest> | undefined): boolean {
    return proto2.util.equals(RemixAndResampleRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.RemixAndResampleResponse
 */
export class RemixAndResampleResponse extends Message<RemixAndResampleResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioFrameBuffer buffer = 1;
   */
  buffer?: OwnedAudioFrameBuffer;

  constructor(data?: PartialMessage<RemixAndResampleResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RemixAndResampleResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "buffer", kind: "message", T: OwnedAudioFrameBuffer, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RemixAndResampleResponse {
    return new RemixAndResampleResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RemixAndResampleResponse {
    return new RemixAndResampleResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RemixAndResampleResponse {
    return new RemixAndResampleResponse().fromJsonString(jsonString, options);
  }

  static equals(a: RemixAndResampleResponse | PlainMessage<RemixAndResampleResponse> | undefined, b: RemixAndResampleResponse | PlainMessage<RemixAndResampleResponse> | undefined): boolean {
    return proto2.util.equals(RemixAndResampleResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewApmRequest
 */
export class NewApmRequest extends Message<NewApmRequest> {
  /**
   * @generated from field: required bool echo_canceller_enabled = 1;
   */
  echoCancellerEnabled?: boolean;

  /**
   * @generated from field: required bool gain_controller_enabled = 2;
   */
  gainControllerEnabled?: boolean;

  /**
   * @generated from field: required bool high_pass_filter_enabled = 3;
   */
  highPassFilterEnabled?: boolean;

  /**
   * @generated from field: required bool noise_suppression_enabled = 4;
   */
  noiseSuppressionEnabled?: boolean;

  constructor(data?: PartialMessage<NewApmRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewApmRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "echo_canceller_enabled", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 2, name: "gain_controller_enabled", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 3, name: "high_pass_filter_enabled", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 4, name: "noise_suppression_enabled", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewApmRequest {
    return new NewApmRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewApmRequest {
    return new NewApmRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewApmRequest {
    return new NewApmRequest().fromJsonString(jsonString, options);
  }

  static equals(a: NewApmRequest | PlainMessage<NewApmRequest> | undefined, b: NewApmRequest | PlainMessage<NewApmRequest> | undefined): boolean {
    return proto2.util.equals(NewApmRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewApmResponse
 */
export class NewApmResponse extends Message<NewApmResponse> {
  /**
   * @generated from field: required livekit.proto.OwnedApm apm = 1;
   */
  apm?: OwnedApm;

  constructor(data?: PartialMessage<NewApmResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewApmResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "apm", kind: "message", T: OwnedApm, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewApmResponse {
    return new NewApmResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewApmResponse {
    return new NewApmResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewApmResponse {
    return new NewApmResponse().fromJsonString(jsonString, options);
  }

  static equals(a: NewApmResponse | PlainMessage<NewApmResponse> | undefined, b: NewApmResponse | PlainMessage<NewApmResponse> | undefined): boolean {
    return proto2.util.equals(NewApmResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmProcessStreamRequest
 */
export class ApmProcessStreamRequest extends Message<ApmProcessStreamRequest> {
  /**
   * @generated from field: required uint64 apm_handle = 1;
   */
  apmHandle?: bigint;

  /**
   * *mut i16
   *
   * @generated from field: required uint64 data_ptr = 2;
   */
  dataPtr?: bigint;

  /**
   * in bytes
   *
   * @generated from field: required uint32 size = 3;
   */
  size?: number;

  /**
   * @generated from field: required uint32 sample_rate = 4;
   */
  sampleRate?: number;

  /**
   * @generated from field: required uint32 num_channels = 5;
   */
  numChannels?: number;

  constructor(data?: PartialMessage<ApmProcessStreamRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmProcessStreamRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "apm_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "size", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 5, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmProcessStreamRequest {
    return new ApmProcessStreamRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmProcessStreamRequest {
    return new ApmProcessStreamRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmProcessStreamRequest {
    return new ApmProcessStreamRequest().fromJsonString(jsonString, options);
  }

  static equals(a: ApmProcessStreamRequest | PlainMessage<ApmProcessStreamRequest> | undefined, b: ApmProcessStreamRequest | PlainMessage<ApmProcessStreamRequest> | undefined): boolean {
    return proto2.util.equals(ApmProcessStreamRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmProcessStreamResponse
 */
export class ApmProcessStreamResponse extends Message<ApmProcessStreamResponse> {
  /**
   * @generated from field: optional string error = 1;
   */
  error?: string;

  constructor(data?: PartialMessage<ApmProcessStreamResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmProcessStreamResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmProcessStreamResponse {
    return new ApmProcessStreamResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmProcessStreamResponse {
    return new ApmProcessStreamResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmProcessStreamResponse {
    return new ApmProcessStreamResponse().fromJsonString(jsonString, options);
  }

  static equals(a: ApmProcessStreamResponse | PlainMessage<ApmProcessStreamResponse> | undefined, b: ApmProcessStreamResponse | PlainMessage<ApmProcessStreamResponse> | undefined): boolean {
    return proto2.util.equals(ApmProcessStreamResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmProcessReverseStreamRequest
 */
export class ApmProcessReverseStreamRequest extends Message<ApmProcessReverseStreamRequest> {
  /**
   * @generated from field: required uint64 apm_handle = 1;
   */
  apmHandle?: bigint;

  /**
   * *mut i16
   *
   * @generated from field: required uint64 data_ptr = 2;
   */
  dataPtr?: bigint;

  /**
   * in bytes
   *
   * @generated from field: required uint32 size = 3;
   */
  size?: number;

  /**
   * @generated from field: required uint32 sample_rate = 4;
   */
  sampleRate?: number;

  /**
   * @generated from field: required uint32 num_channels = 5;
   */
  numChannels?: number;

  constructor(data?: PartialMessage<ApmProcessReverseStreamRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmProcessReverseStreamRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "apm_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "size", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 5, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmProcessReverseStreamRequest {
    return new ApmProcessReverseStreamRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmProcessReverseStreamRequest {
    return new ApmProcessReverseStreamRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmProcessReverseStreamRequest {
    return new ApmProcessReverseStreamRequest().fromJsonString(jsonString, options);
  }

  static equals(a: ApmProcessReverseStreamRequest | PlainMessage<ApmProcessReverseStreamRequest> | undefined, b: ApmProcessReverseStreamRequest | PlainMessage<ApmProcessReverseStreamRequest> | undefined): boolean {
    return proto2.util.equals(ApmProcessReverseStreamRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmProcessReverseStreamResponse
 */
export class ApmProcessReverseStreamResponse extends Message<ApmProcessReverseStreamResponse> {
  /**
   * @generated from field: optional string error = 1;
   */
  error?: string;

  constructor(data?: PartialMessage<ApmProcessReverseStreamResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmProcessReverseStreamResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmProcessReverseStreamResponse {
    return new ApmProcessReverseStreamResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmProcessReverseStreamResponse {
    return new ApmProcessReverseStreamResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmProcessReverseStreamResponse {
    return new ApmProcessReverseStreamResponse().fromJsonString(jsonString, options);
  }

  static equals(a: ApmProcessReverseStreamResponse | PlainMessage<ApmProcessReverseStreamResponse> | undefined, b: ApmProcessReverseStreamResponse | PlainMessage<ApmProcessReverseStreamResponse> | undefined): boolean {
    return proto2.util.equals(ApmProcessReverseStreamResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmSetStreamDelayRequest
 */
export class ApmSetStreamDelayRequest extends Message<ApmSetStreamDelayRequest> {
  /**
   * @generated from field: required uint64 apm_handle = 1;
   */
  apmHandle?: bigint;

  /**
   * @generated from field: required int32 delay_ms = 2;
   */
  delayMs?: number;

  constructor(data?: PartialMessage<ApmSetStreamDelayRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmSetStreamDelayRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "apm_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "delay_ms", kind: "scalar", T: 5 /* ScalarType.INT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmSetStreamDelayRequest {
    return new ApmSetStreamDelayRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmSetStreamDelayRequest {
    return new ApmSetStreamDelayRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmSetStreamDelayRequest {
    return new ApmSetStreamDelayRequest().fromJsonString(jsonString, options);
  }

  static equals(a: ApmSetStreamDelayRequest | PlainMessage<ApmSetStreamDelayRequest> | undefined, b: ApmSetStreamDelayRequest | PlainMessage<ApmSetStreamDelayRequest> | undefined): boolean {
    return proto2.util.equals(ApmSetStreamDelayRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.ApmSetStreamDelayResponse
 */
export class ApmSetStreamDelayResponse extends Message<ApmSetStreamDelayResponse> {
  /**
   * @generated from field: optional string error = 1;
   */
  error?: string;

  constructor(data?: PartialMessage<ApmSetStreamDelayResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ApmSetStreamDelayResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ApmSetStreamDelayResponse {
    return new ApmSetStreamDelayResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ApmSetStreamDelayResponse {
    return new ApmSetStreamDelayResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ApmSetStreamDelayResponse {
    return new ApmSetStreamDelayResponse().fromJsonString(jsonString, options);
  }

  static equals(a: ApmSetStreamDelayResponse | PlainMessage<ApmSetStreamDelayResponse> | undefined, b: ApmSetStreamDelayResponse | PlainMessage<ApmSetStreamDelayResponse> | undefined): boolean {
    return proto2.util.equals(ApmSetStreamDelayResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewSoxResamplerRequest
 */
export class NewSoxResamplerRequest extends Message<NewSoxResamplerRequest> {
  /**
   * @generated from field: required double input_rate = 1;
   */
  inputRate?: number;

  /**
   * @generated from field: required double output_rate = 2;
   */
  outputRate?: number;

  /**
   * @generated from field: required uint32 num_channels = 3;
   */
  numChannels?: number;

  /**
   * @generated from field: required livekit.proto.SoxResamplerDataType input_data_type = 4;
   */
  inputDataType?: SoxResamplerDataType;

  /**
   * @generated from field: required livekit.proto.SoxResamplerDataType output_data_type = 5;
   */
  outputDataType?: SoxResamplerDataType;

  /**
   * @generated from field: required livekit.proto.SoxQualityRecipe quality_recipe = 6;
   */
  qualityRecipe?: SoxQualityRecipe;

  /**
   * @generated from field: optional uint32 flags = 7;
   */
  flags?: number;

  constructor(data?: PartialMessage<NewSoxResamplerRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewSoxResamplerRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "input_rate", kind: "scalar", T: 1 /* ScalarType.DOUBLE */, req: true },
    { no: 2, name: "output_rate", kind: "scalar", T: 1 /* ScalarType.DOUBLE */, req: true },
    { no: 3, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "input_data_type", kind: "enum", T: proto2.getEnumType(SoxResamplerDataType), req: true },
    { no: 5, name: "output_data_type", kind: "enum", T: proto2.getEnumType(SoxResamplerDataType), req: true },
    { no: 6, name: "quality_recipe", kind: "enum", T: proto2.getEnumType(SoxQualityRecipe), req: true },
    { no: 7, name: "flags", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewSoxResamplerRequest {
    return new NewSoxResamplerRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewSoxResamplerRequest {
    return new NewSoxResamplerRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewSoxResamplerRequest {
    return new NewSoxResamplerRequest().fromJsonString(jsonString, options);
  }

  static equals(a: NewSoxResamplerRequest | PlainMessage<NewSoxResamplerRequest> | undefined, b: NewSoxResamplerRequest | PlainMessage<NewSoxResamplerRequest> | undefined): boolean {
    return proto2.util.equals(NewSoxResamplerRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.NewSoxResamplerResponse
 */
export class NewSoxResamplerResponse extends Message<NewSoxResamplerResponse> {
  /**
   * @generated from oneof livekit.proto.NewSoxResamplerResponse.message
   */
  message: {
    /**
     * @generated from field: livekit.proto.OwnedSoxResampler resampler = 1;
     */
    value: OwnedSoxResampler;
    case: "resampler";
  } | {
    /**
     * @generated from field: string error = 2;
     */
    value: string;
    case: "error";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<NewSoxResamplerResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.NewSoxResamplerResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "resampler", kind: "message", T: OwnedSoxResampler, oneof: "message" },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): NewSoxResamplerResponse {
    return new NewSoxResamplerResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): NewSoxResamplerResponse {
    return new NewSoxResamplerResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): NewSoxResamplerResponse {
    return new NewSoxResamplerResponse().fromJsonString(jsonString, options);
  }

  static equals(a: NewSoxResamplerResponse | PlainMessage<NewSoxResamplerResponse> | undefined, b: NewSoxResamplerResponse | PlainMessage<NewSoxResamplerResponse> | undefined): boolean {
    return proto2.util.equals(NewSoxResamplerResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.PushSoxResamplerRequest
 */
export class PushSoxResamplerRequest extends Message<PushSoxResamplerRequest> {
  /**
   * @generated from field: required uint64 resampler_handle = 1;
   */
  resamplerHandle?: bigint;

  /**
   * *const i16
   *
   * @generated from field: required uint64 data_ptr = 2;
   */
  dataPtr?: bigint;

  /**
   * in bytes
   *
   * @generated from field: required uint32 size = 3;
   */
  size?: number;

  constructor(data?: PartialMessage<PushSoxResamplerRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PushSoxResamplerRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "resampler_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "size", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PushSoxResamplerRequest {
    return new PushSoxResamplerRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PushSoxResamplerRequest {
    return new PushSoxResamplerRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PushSoxResamplerRequest {
    return new PushSoxResamplerRequest().fromJsonString(jsonString, options);
  }

  static equals(a: PushSoxResamplerRequest | PlainMessage<PushSoxResamplerRequest> | undefined, b: PushSoxResamplerRequest | PlainMessage<PushSoxResamplerRequest> | undefined): boolean {
    return proto2.util.equals(PushSoxResamplerRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.PushSoxResamplerResponse
 */
export class PushSoxResamplerResponse extends Message<PushSoxResamplerResponse> {
  /**
   * *const i16 (could be null)
   *
   * @generated from field: required uint64 output_ptr = 1;
   */
  outputPtr?: bigint;

  /**
   * in bytes
   *
   * @generated from field: required uint32 size = 2;
   */
  size?: number;

  /**
   * @generated from field: optional string error = 3;
   */
  error?: string;

  constructor(data?: PartialMessage<PushSoxResamplerResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PushSoxResamplerResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "output_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "size", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 3, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PushSoxResamplerResponse {
    return new PushSoxResamplerResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PushSoxResamplerResponse {
    return new PushSoxResamplerResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PushSoxResamplerResponse {
    return new PushSoxResamplerResponse().fromJsonString(jsonString, options);
  }

  static equals(a: PushSoxResamplerResponse | PlainMessage<PushSoxResamplerResponse> | undefined, b: PushSoxResamplerResponse | PlainMessage<PushSoxResamplerResponse> | undefined): boolean {
    return proto2.util.equals(PushSoxResamplerResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.FlushSoxResamplerRequest
 */
export class FlushSoxResamplerRequest extends Message<FlushSoxResamplerRequest> {
  /**
   * @generated from field: required uint64 resampler_handle = 1;
   */
  resamplerHandle?: bigint;

  constructor(data?: PartialMessage<FlushSoxResamplerRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.FlushSoxResamplerRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "resampler_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): FlushSoxResamplerRequest {
    return new FlushSoxResamplerRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): FlushSoxResamplerRequest {
    return new FlushSoxResamplerRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): FlushSoxResamplerRequest {
    return new FlushSoxResamplerRequest().fromJsonString(jsonString, options);
  }

  static equals(a: FlushSoxResamplerRequest | PlainMessage<FlushSoxResamplerRequest> | undefined, b: FlushSoxResamplerRequest | PlainMessage<FlushSoxResamplerRequest> | undefined): boolean {
    return proto2.util.equals(FlushSoxResamplerRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.FlushSoxResamplerResponse
 */
export class FlushSoxResamplerResponse extends Message<FlushSoxResamplerResponse> {
  /**
   * *const i16 (could be null)
   *
   * @generated from field: required uint64 output_ptr = 1;
   */
  outputPtr?: bigint;

  /**
   * in bytes
   *
   * @generated from field: required uint32 size = 2;
   */
  size?: number;

  /**
   * @generated from field: optional string error = 3;
   */
  error?: string;

  constructor(data?: PartialMessage<FlushSoxResamplerResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.FlushSoxResamplerResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "output_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "size", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 3, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): FlushSoxResamplerResponse {
    return new FlushSoxResamplerResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): FlushSoxResamplerResponse {
    return new FlushSoxResamplerResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): FlushSoxResamplerResponse {
    return new FlushSoxResamplerResponse().fromJsonString(jsonString, options);
  }

  static equals(a: FlushSoxResamplerResponse | PlainMessage<FlushSoxResamplerResponse> | undefined, b: FlushSoxResamplerResponse | PlainMessage<FlushSoxResamplerResponse> | undefined): boolean {
    return proto2.util.equals(FlushSoxResamplerResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioFrameBufferInfo
 */
export class AudioFrameBufferInfo extends Message<AudioFrameBufferInfo> {
  /**
   * *const i16
   *
   * @generated from field: required uint64 data_ptr = 1;
   */
  dataPtr?: bigint;

  /**
   * @generated from field: required uint32 num_channels = 2;
   */
  numChannels?: number;

  /**
   * @generated from field: required uint32 sample_rate = 3;
   */
  sampleRate?: number;

  /**
   * @generated from field: required uint32 samples_per_channel = 4;
   */
  samplesPerChannel?: number;

  constructor(data?: PartialMessage<AudioFrameBufferInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioFrameBufferInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "num_channels", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 3, name: "sample_rate", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 4, name: "samples_per_channel", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioFrameBufferInfo {
    return new AudioFrameBufferInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioFrameBufferInfo {
    return new AudioFrameBufferInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioFrameBufferInfo {
    return new AudioFrameBufferInfo().fromJsonString(jsonString, options);
  }

  static equals(a: AudioFrameBufferInfo | PlainMessage<AudioFrameBufferInfo> | undefined, b: AudioFrameBufferInfo | PlainMessage<AudioFrameBufferInfo> | undefined): boolean {
    return proto2.util.equals(AudioFrameBufferInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedAudioFrameBuffer
 */
export class OwnedAudioFrameBuffer extends Message<OwnedAudioFrameBuffer> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.AudioFrameBufferInfo info = 2;
   */
  info?: AudioFrameBufferInfo;

  constructor(data?: PartialMessage<OwnedAudioFrameBuffer>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedAudioFrameBuffer";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: AudioFrameBufferInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedAudioFrameBuffer {
    return new OwnedAudioFrameBuffer().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedAudioFrameBuffer {
    return new OwnedAudioFrameBuffer().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedAudioFrameBuffer {
    return new OwnedAudioFrameBuffer().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedAudioFrameBuffer | PlainMessage<OwnedAudioFrameBuffer> | undefined, b: OwnedAudioFrameBuffer | PlainMessage<OwnedAudioFrameBuffer> | undefined): boolean {
    return proto2.util.equals(OwnedAudioFrameBuffer, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioStreamInfo
 */
export class AudioStreamInfo extends Message<AudioStreamInfo> {
  /**
   * @generated from field: required livekit.proto.AudioStreamType type = 1;
   */
  type?: AudioStreamType;

  constructor(data?: PartialMessage<AudioStreamInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioStreamInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "type", kind: "enum", T: proto2.getEnumType(AudioStreamType), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioStreamInfo {
    return new AudioStreamInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioStreamInfo {
    return new AudioStreamInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioStreamInfo {
    return new AudioStreamInfo().fromJsonString(jsonString, options);
  }

  static equals(a: AudioStreamInfo | PlainMessage<AudioStreamInfo> | undefined, b: AudioStreamInfo | PlainMessage<AudioStreamInfo> | undefined): boolean {
    return proto2.util.equals(AudioStreamInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedAudioStream
 */
export class OwnedAudioStream extends Message<OwnedAudioStream> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.AudioStreamInfo info = 2;
   */
  info?: AudioStreamInfo;

  constructor(data?: PartialMessage<OwnedAudioStream>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedAudioStream";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: AudioStreamInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedAudioStream {
    return new OwnedAudioStream().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedAudioStream {
    return new OwnedAudioStream().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedAudioStream {
    return new OwnedAudioStream().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedAudioStream | PlainMessage<OwnedAudioStream> | undefined, b: OwnedAudioStream | PlainMessage<OwnedAudioStream> | undefined): boolean {
    return proto2.util.equals(OwnedAudioStream, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioStreamEvent
 */
export class AudioStreamEvent extends Message<AudioStreamEvent> {
  /**
   * @generated from field: required uint64 stream_handle = 1;
   */
  streamHandle?: bigint;

  /**
   * @generated from oneof livekit.proto.AudioStreamEvent.message
   */
  message: {
    /**
     * @generated from field: livekit.proto.AudioFrameReceived frame_received = 2;
     */
    value: AudioFrameReceived;
    case: "frameReceived";
  } | {
    /**
     * @generated from field: livekit.proto.AudioStreamEOS eos = 3;
     */
    value: AudioStreamEOS;
    case: "eos";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<AudioStreamEvent>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioStreamEvent";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "frame_received", kind: "message", T: AudioFrameReceived, oneof: "message" },
    { no: 3, name: "eos", kind: "message", T: AudioStreamEOS, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioStreamEvent {
    return new AudioStreamEvent().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioStreamEvent {
    return new AudioStreamEvent().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioStreamEvent {
    return new AudioStreamEvent().fromJsonString(jsonString, options);
  }

  static equals(a: AudioStreamEvent | PlainMessage<AudioStreamEvent> | undefined, b: AudioStreamEvent | PlainMessage<AudioStreamEvent> | undefined): boolean {
    return proto2.util.equals(AudioStreamEvent, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioFrameReceived
 */
export class AudioFrameReceived extends Message<AudioFrameReceived> {
  /**
   * @generated from field: required livekit.proto.OwnedAudioFrameBuffer frame = 1;
   */
  frame?: OwnedAudioFrameBuffer;

  constructor(data?: PartialMessage<AudioFrameReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioFrameReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "frame", kind: "message", T: OwnedAudioFrameBuffer, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioFrameReceived {
    return new AudioFrameReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioFrameReceived {
    return new AudioFrameReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioFrameReceived {
    return new AudioFrameReceived().fromJsonString(jsonString, options);
  }

  static equals(a: AudioFrameReceived | PlainMessage<AudioFrameReceived> | undefined, b: AudioFrameReceived | PlainMessage<AudioFrameReceived> | undefined): boolean {
    return proto2.util.equals(AudioFrameReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioStreamEOS
 */
export class AudioStreamEOS extends Message<AudioStreamEOS> {
  constructor(data?: PartialMessage<AudioStreamEOS>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioStreamEOS";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioStreamEOS {
    return new AudioStreamEOS().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioStreamEOS {
    return new AudioStreamEOS().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioStreamEOS {
    return new AudioStreamEOS().fromJsonString(jsonString, options);
  }

  static equals(a: AudioStreamEOS | PlainMessage<AudioStreamEOS> | undefined, b: AudioStreamEOS | PlainMessage<AudioStreamEOS> | undefined): boolean {
    return proto2.util.equals(AudioStreamEOS, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioSourceOptions
 */
export class AudioSourceOptions extends Message<AudioSourceOptions> {
  /**
   * @generated from field: required bool echo_cancellation = 1;
   */
  echoCancellation?: boolean;

  /**
   * @generated from field: required bool noise_suppression = 2;
   */
  noiseSuppression?: boolean;

  /**
   * @generated from field: required bool auto_gain_control = 3;
   */
  autoGainControl?: boolean;

  constructor(data?: PartialMessage<AudioSourceOptions>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioSourceOptions";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "echo_cancellation", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 2, name: "noise_suppression", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 3, name: "auto_gain_control", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioSourceOptions {
    return new AudioSourceOptions().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioSourceOptions {
    return new AudioSourceOptions().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioSourceOptions {
    return new AudioSourceOptions().fromJsonString(jsonString, options);
  }

  static equals(a: AudioSourceOptions | PlainMessage<AudioSourceOptions> | undefined, b: AudioSourceOptions | PlainMessage<AudioSourceOptions> | undefined): boolean {
    return proto2.util.equals(AudioSourceOptions, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioSourceInfo
 */
export class AudioSourceInfo extends Message<AudioSourceInfo> {
  /**
   * @generated from field: required livekit.proto.AudioSourceType type = 2;
   */
  type?: AudioSourceType;

  constructor(data?: PartialMessage<AudioSourceInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioSourceInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 2, name: "type", kind: "enum", T: proto2.getEnumType(AudioSourceType), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioSourceInfo {
    return new AudioSourceInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioSourceInfo {
    return new AudioSourceInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioSourceInfo {
    return new AudioSourceInfo().fromJsonString(jsonString, options);
  }

  static equals(a: AudioSourceInfo | PlainMessage<AudioSourceInfo> | undefined, b: AudioSourceInfo | PlainMessage<AudioSourceInfo> | undefined): boolean {
    return proto2.util.equals(AudioSourceInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedAudioSource
 */
export class OwnedAudioSource extends Message<OwnedAudioSource> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.AudioSourceInfo info = 2;
   */
  info?: AudioSourceInfo;

  constructor(data?: PartialMessage<OwnedAudioSource>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedAudioSource";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: AudioSourceInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedAudioSource {
    return new OwnedAudioSource().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedAudioSource {
    return new OwnedAudioSource().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedAudioSource {
    return new OwnedAudioSource().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedAudioSource | PlainMessage<OwnedAudioSource> | undefined, b: OwnedAudioSource | PlainMessage<OwnedAudioSource> | undefined): boolean {
    return proto2.util.equals(OwnedAudioSource, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioResamplerInfo
 */
export class AudioResamplerInfo extends Message<AudioResamplerInfo> {
  constructor(data?: PartialMessage<AudioResamplerInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioResamplerInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioResamplerInfo {
    return new AudioResamplerInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioResamplerInfo {
    return new AudioResamplerInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioResamplerInfo {
    return new AudioResamplerInfo().fromJsonString(jsonString, options);
  }

  static equals(a: AudioResamplerInfo | PlainMessage<AudioResamplerInfo> | undefined, b: AudioResamplerInfo | PlainMessage<AudioResamplerInfo> | undefined): boolean {
    return proto2.util.equals(AudioResamplerInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedAudioResampler
 */
export class OwnedAudioResampler extends Message<OwnedAudioResampler> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.AudioResamplerInfo info = 2;
   */
  info?: AudioResamplerInfo;

  constructor(data?: PartialMessage<OwnedAudioResampler>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedAudioResampler";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: AudioResamplerInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedAudioResampler {
    return new OwnedAudioResampler().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedAudioResampler {
    return new OwnedAudioResampler().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedAudioResampler {
    return new OwnedAudioResampler().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedAudioResampler | PlainMessage<OwnedAudioResampler> | undefined, b: OwnedAudioResampler | PlainMessage<OwnedAudioResampler> | undefined): boolean {
    return proto2.util.equals(OwnedAudioResampler, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedApm
 */
export class OwnedApm extends Message<OwnedApm> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  constructor(data?: PartialMessage<OwnedApm>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedApm";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedApm {
    return new OwnedApm().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedApm {
    return new OwnedApm().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedApm {
    return new OwnedApm().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedApm | PlainMessage<OwnedApm> | undefined, b: OwnedApm | PlainMessage<OwnedApm> | undefined): boolean {
    return proto2.util.equals(OwnedApm, a, b);
  }
}

/**
 * @generated from message livekit.proto.SoxResamplerInfo
 */
export class SoxResamplerInfo extends Message<SoxResamplerInfo> {
  constructor(data?: PartialMessage<SoxResamplerInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SoxResamplerInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SoxResamplerInfo {
    return new SoxResamplerInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SoxResamplerInfo {
    return new SoxResamplerInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SoxResamplerInfo {
    return new SoxResamplerInfo().fromJsonString(jsonString, options);
  }

  static equals(a: SoxResamplerInfo | PlainMessage<SoxResamplerInfo> | undefined, b: SoxResamplerInfo | PlainMessage<SoxResamplerInfo> | undefined): boolean {
    return proto2.util.equals(SoxResamplerInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedSoxResampler
 */
export class OwnedSoxResampler extends Message<OwnedSoxResampler> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.SoxResamplerInfo info = 2;
   */
  info?: SoxResamplerInfo;

  constructor(data?: PartialMessage<OwnedSoxResampler>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedSoxResampler";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: SoxResamplerInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedSoxResampler {
    return new OwnedSoxResampler().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedSoxResampler {
    return new OwnedSoxResampler().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedSoxResampler {
    return new OwnedSoxResampler().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedSoxResampler | PlainMessage<OwnedSoxResampler> | undefined, b: OwnedSoxResampler | PlainMessage<OwnedSoxResampler> | undefined): boolean {
    return proto2.util.equals(OwnedSoxResampler, a, b);
  }
}

/**
 * Audio Filter Plugin
 *
 * @generated from message livekit.proto.LoadAudioFilterPluginRequest
 */
export class LoadAudioFilterPluginRequest extends Message<LoadAudioFilterPluginRequest> {
  /**
   * path for ffi audio filter plugin
   *
   * @generated from field: required string plugin_path = 1;
   */
  pluginPath?: string;

  /**
   * Optional: paths for dependency dylibs
   *
   * @generated from field: repeated string dependencies = 2;
   */
  dependencies: string[] = [];

  /**
   * Unique identifier of the plugin
   *
   * @generated from field: required string module_id = 3;
   */
  moduleId?: string;

  constructor(data?: PartialMessage<LoadAudioFilterPluginRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.LoadAudioFilterPluginRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "plugin_path", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "dependencies", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 3, name: "module_id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): LoadAudioFilterPluginRequest {
    return new LoadAudioFilterPluginRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): LoadAudioFilterPluginRequest {
    return new LoadAudioFilterPluginRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): LoadAudioFilterPluginRequest {
    return new LoadAudioFilterPluginRequest().fromJsonString(jsonString, options);
  }

  static equals(a: LoadAudioFilterPluginRequest | PlainMessage<LoadAudioFilterPluginRequest> | undefined, b: LoadAudioFilterPluginRequest | PlainMessage<LoadAudioFilterPluginRequest> | undefined): boolean {
    return proto2.util.equals(LoadAudioFilterPluginRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.LoadAudioFilterPluginResponse
 */
export class LoadAudioFilterPluginResponse extends Message<LoadAudioFilterPluginResponse> {
  /**
   * @generated from field: optional string error = 1;
   */
  error?: string;

  constructor(data?: PartialMessage<LoadAudioFilterPluginResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.LoadAudioFilterPluginResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): LoadAudioFilterPluginResponse {
    return new LoadAudioFilterPluginResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): LoadAudioFilterPluginResponse {
    return new LoadAudioFilterPluginResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): LoadAudioFilterPluginResponse {
    return new LoadAudioFilterPluginResponse().fromJsonString(jsonString, options);
  }

  static equals(a: LoadAudioFilterPluginResponse | PlainMessage<LoadAudioFilterPluginResponse> | undefined, b: LoadAudioFilterPluginResponse | PlainMessage<LoadAudioFilterPluginResponse> | undefined): boolean {
    return proto2.util.equals(LoadAudioFilterPluginResponse, a, b);
  }
}

