// Copyright 2023 LiveKit, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.10.0 with parameter "target=ts,import_extension=.js"
// @generated from file room.proto (package livekit.proto, syntax proto2)
/* eslint-disable */
// @ts-nocheck

import type { BinaryReadOptions, FieldList, JsonReadOptions, JsonValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto2 } from "@bufbuild/protobuf";
import { DisconnectReason, OwnedParticipant } from "./participant_pb.js";
import { OwnedTrack, OwnedTrackPublication, TrackSource } from "./track_pb.js";
import { RtcStats } from "./stats_pb.js";
import { VideoCodec } from "./video_frame_pb.js";
import { E2eeOptions, EncryptionState } from "./e2ee_pb.js";
import { FfiOwnedHandle } from "./handle_pb.js";

/**
 * @generated from enum livekit.proto.IceTransportType
 */
export enum IceTransportType {
  /**
   * @generated from enum value: TRANSPORT_RELAY = 0;
   */
  TRANSPORT_RELAY = 0,

  /**
   * @generated from enum value: TRANSPORT_NOHOST = 1;
   */
  TRANSPORT_NOHOST = 1,

  /**
   * @generated from enum value: TRANSPORT_ALL = 2;
   */
  TRANSPORT_ALL = 2,
}
// Retrieve enum metadata with: proto2.getEnumType(IceTransportType)
proto2.util.setEnumType(IceTransportType, "livekit.proto.IceTransportType", [
  { no: 0, name: "TRANSPORT_RELAY" },
  { no: 1, name: "TRANSPORT_NOHOST" },
  { no: 2, name: "TRANSPORT_ALL" },
]);

/**
 * @generated from enum livekit.proto.ContinualGatheringPolicy
 */
export enum ContinualGatheringPolicy {
  /**
   * @generated from enum value: GATHER_ONCE = 0;
   */
  GATHER_ONCE = 0,

  /**
   * @generated from enum value: GATHER_CONTINUALLY = 1;
   */
  GATHER_CONTINUALLY = 1,
}
// Retrieve enum metadata with: proto2.getEnumType(ContinualGatheringPolicy)
proto2.util.setEnumType(ContinualGatheringPolicy, "livekit.proto.ContinualGatheringPolicy", [
  { no: 0, name: "GATHER_ONCE" },
  { no: 1, name: "GATHER_CONTINUALLY" },
]);

/**
 * @generated from enum livekit.proto.ConnectionQuality
 */
export enum ConnectionQuality {
  /**
   * @generated from enum value: QUALITY_POOR = 0;
   */
  QUALITY_POOR = 0,

  /**
   * @generated from enum value: QUALITY_GOOD = 1;
   */
  QUALITY_GOOD = 1,

  /**
   * @generated from enum value: QUALITY_EXCELLENT = 2;
   */
  QUALITY_EXCELLENT = 2,

  /**
   * @generated from enum value: QUALITY_LOST = 3;
   */
  QUALITY_LOST = 3,
}
// Retrieve enum metadata with: proto2.getEnumType(ConnectionQuality)
proto2.util.setEnumType(ConnectionQuality, "livekit.proto.ConnectionQuality", [
  { no: 0, name: "QUALITY_POOR" },
  { no: 1, name: "QUALITY_GOOD" },
  { no: 2, name: "QUALITY_EXCELLENT" },
  { no: 3, name: "QUALITY_LOST" },
]);

/**
 * @generated from enum livekit.proto.ConnectionState
 */
export enum ConnectionState {
  /**
   * @generated from enum value: CONN_DISCONNECTED = 0;
   */
  CONN_DISCONNECTED = 0,

  /**
   * @generated from enum value: CONN_CONNECTED = 1;
   */
  CONN_CONNECTED = 1,

  /**
   * @generated from enum value: CONN_RECONNECTING = 2;
   */
  CONN_RECONNECTING = 2,
}
// Retrieve enum metadata with: proto2.getEnumType(ConnectionState)
proto2.util.setEnumType(ConnectionState, "livekit.proto.ConnectionState", [
  { no: 0, name: "CONN_DISCONNECTED" },
  { no: 1, name: "CONN_CONNECTED" },
  { no: 2, name: "CONN_RECONNECTING" },
]);

/**
 * @generated from enum livekit.proto.DataPacketKind
 */
export enum DataPacketKind {
  /**
   * @generated from enum value: KIND_LOSSY = 0;
   */
  KIND_LOSSY = 0,

  /**
   * @generated from enum value: KIND_RELIABLE = 1;
   */
  KIND_RELIABLE = 1,
}
// Retrieve enum metadata with: proto2.getEnumType(DataPacketKind)
proto2.util.setEnumType(DataPacketKind, "livekit.proto.DataPacketKind", [
  { no: 0, name: "KIND_LOSSY" },
  { no: 1, name: "KIND_RELIABLE" },
]);

/**
 * Connect to a new LiveKit room
 *
 * @generated from message livekit.proto.ConnectRequest
 */
export class ConnectRequest extends Message<ConnectRequest> {
  /**
   * @generated from field: required string url = 1;
   */
  url?: string;

  /**
   * @generated from field: required string token = 2;
   */
  token?: string;

  /**
   * @generated from field: required livekit.proto.RoomOptions options = 3;
   */
  options?: RoomOptions;

  constructor(data?: PartialMessage<ConnectRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "url", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "token", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "options", kind: "message", T: RoomOptions, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectRequest {
    return new ConnectRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectRequest {
    return new ConnectRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectRequest {
    return new ConnectRequest().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectRequest | PlainMessage<ConnectRequest> | undefined, b: ConnectRequest | PlainMessage<ConnectRequest> | undefined): boolean {
    return proto2.util.equals(ConnectRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectResponse
 */
export class ConnectResponse extends Message<ConnectResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<ConnectResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectResponse {
    return new ConnectResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectResponse {
    return new ConnectResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectResponse {
    return new ConnectResponse().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectResponse | PlainMessage<ConnectResponse> | undefined, b: ConnectResponse | PlainMessage<ConnectResponse> | undefined): boolean {
    return proto2.util.equals(ConnectResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectCallback
 */
export class ConnectCallback extends Message<ConnectCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from oneof livekit.proto.ConnectCallback.message
   */
  message: {
    /**
     * @generated from field: string error = 2;
     */
    value: string;
    case: "error";
  } | {
    /**
     * @generated from field: livekit.proto.ConnectCallback.Result result = 3;
     */
    value: ConnectCallback_Result;
    case: "result";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<ConnectCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "message" },
    { no: 3, name: "result", kind: "message", T: ConnectCallback_Result, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectCallback {
    return new ConnectCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectCallback {
    return new ConnectCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectCallback {
    return new ConnectCallback().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectCallback | PlainMessage<ConnectCallback> | undefined, b: ConnectCallback | PlainMessage<ConnectCallback> | undefined): boolean {
    return proto2.util.equals(ConnectCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectCallback.ParticipantWithTracks
 */
export class ConnectCallback_ParticipantWithTracks extends Message<ConnectCallback_ParticipantWithTracks> {
  /**
   * @generated from field: required livekit.proto.OwnedParticipant participant = 1;
   */
  participant?: OwnedParticipant;

  /**
   * TrackInfo are not needed here, if we're subscribed to a track, the FfiServer will send
   * a TrackSubscribed event
   *
   * @generated from field: repeated livekit.proto.OwnedTrackPublication publications = 2;
   */
  publications: OwnedTrackPublication[] = [];

  constructor(data?: PartialMessage<ConnectCallback_ParticipantWithTracks>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectCallback.ParticipantWithTracks";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant", kind: "message", T: OwnedParticipant, req: true },
    { no: 2, name: "publications", kind: "message", T: OwnedTrackPublication, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectCallback_ParticipantWithTracks {
    return new ConnectCallback_ParticipantWithTracks().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectCallback_ParticipantWithTracks {
    return new ConnectCallback_ParticipantWithTracks().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectCallback_ParticipantWithTracks {
    return new ConnectCallback_ParticipantWithTracks().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectCallback_ParticipantWithTracks | PlainMessage<ConnectCallback_ParticipantWithTracks> | undefined, b: ConnectCallback_ParticipantWithTracks | PlainMessage<ConnectCallback_ParticipantWithTracks> | undefined): boolean {
    return proto2.util.equals(ConnectCallback_ParticipantWithTracks, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectCallback.Result
 */
export class ConnectCallback_Result extends Message<ConnectCallback_Result> {
  /**
   * @generated from field: required livekit.proto.OwnedRoom room = 1;
   */
  room?: OwnedRoom;

  /**
   * @generated from field: required livekit.proto.OwnedParticipant local_participant = 2;
   */
  localParticipant?: OwnedParticipant;

  /**
   * @generated from field: repeated livekit.proto.ConnectCallback.ParticipantWithTracks participants = 3;
   */
  participants: ConnectCallback_ParticipantWithTracks[] = [];

  constructor(data?: PartialMessage<ConnectCallback_Result>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectCallback.Result";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "room", kind: "message", T: OwnedRoom, req: true },
    { no: 2, name: "local_participant", kind: "message", T: OwnedParticipant, req: true },
    { no: 3, name: "participants", kind: "message", T: ConnectCallback_ParticipantWithTracks, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectCallback_Result {
    return new ConnectCallback_Result().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectCallback_Result {
    return new ConnectCallback_Result().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectCallback_Result {
    return new ConnectCallback_Result().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectCallback_Result | PlainMessage<ConnectCallback_Result> | undefined, b: ConnectCallback_Result | PlainMessage<ConnectCallback_Result> | undefined): boolean {
    return proto2.util.equals(ConnectCallback_Result, a, b);
  }
}

/**
 * Disconnect from the a room
 *
 * @generated from message livekit.proto.DisconnectRequest
 */
export class DisconnectRequest extends Message<DisconnectRequest> {
  /**
   * @generated from field: required uint64 room_handle = 1;
   */
  roomHandle?: bigint;

  constructor(data?: PartialMessage<DisconnectRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DisconnectRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "room_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DisconnectRequest {
    return new DisconnectRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DisconnectRequest {
    return new DisconnectRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DisconnectRequest {
    return new DisconnectRequest().fromJsonString(jsonString, options);
  }

  static equals(a: DisconnectRequest | PlainMessage<DisconnectRequest> | undefined, b: DisconnectRequest | PlainMessage<DisconnectRequest> | undefined): boolean {
    return proto2.util.equals(DisconnectRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.DisconnectResponse
 */
export class DisconnectResponse extends Message<DisconnectResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<DisconnectResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DisconnectResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DisconnectResponse {
    return new DisconnectResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DisconnectResponse {
    return new DisconnectResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DisconnectResponse {
    return new DisconnectResponse().fromJsonString(jsonString, options);
  }

  static equals(a: DisconnectResponse | PlainMessage<DisconnectResponse> | undefined, b: DisconnectResponse | PlainMessage<DisconnectResponse> | undefined): boolean {
    return proto2.util.equals(DisconnectResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.DisconnectCallback
 */
export class DisconnectCallback extends Message<DisconnectCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<DisconnectCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DisconnectCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DisconnectCallback {
    return new DisconnectCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DisconnectCallback {
    return new DisconnectCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DisconnectCallback {
    return new DisconnectCallback().fromJsonString(jsonString, options);
  }

  static equals(a: DisconnectCallback | PlainMessage<DisconnectCallback> | undefined, b: DisconnectCallback | PlainMessage<DisconnectCallback> | undefined): boolean {
    return proto2.util.equals(DisconnectCallback, a, b);
  }
}

/**
 * Publish a track to the room
 *
 * @generated from message livekit.proto.PublishTrackRequest
 */
export class PublishTrackRequest extends Message<PublishTrackRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required uint64 track_handle = 2;
   */
  trackHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.TrackPublishOptions options = 3;
   */
  options?: TrackPublishOptions;

  constructor(data?: PartialMessage<PublishTrackRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTrackRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "track_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "options", kind: "message", T: TrackPublishOptions, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTrackRequest {
    return new PublishTrackRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTrackRequest {
    return new PublishTrackRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTrackRequest {
    return new PublishTrackRequest().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTrackRequest | PlainMessage<PublishTrackRequest> | undefined, b: PublishTrackRequest | PlainMessage<PublishTrackRequest> | undefined): boolean {
    return proto2.util.equals(PublishTrackRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishTrackResponse
 */
export class PublishTrackResponse extends Message<PublishTrackResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<PublishTrackResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTrackResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTrackResponse {
    return new PublishTrackResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTrackResponse {
    return new PublishTrackResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTrackResponse {
    return new PublishTrackResponse().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTrackResponse | PlainMessage<PublishTrackResponse> | undefined, b: PublishTrackResponse | PlainMessage<PublishTrackResponse> | undefined): boolean {
    return proto2.util.equals(PublishTrackResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishTrackCallback
 */
export class PublishTrackCallback extends Message<PublishTrackCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from oneof livekit.proto.PublishTrackCallback.message
   */
  message: {
    /**
     * @generated from field: string error = 2;
     */
    value: string;
    case: "error";
  } | {
    /**
     * @generated from field: livekit.proto.OwnedTrackPublication publication = 3;
     */
    value: OwnedTrackPublication;
    case: "publication";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<PublishTrackCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTrackCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "message" },
    { no: 3, name: "publication", kind: "message", T: OwnedTrackPublication, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTrackCallback {
    return new PublishTrackCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTrackCallback {
    return new PublishTrackCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTrackCallback {
    return new PublishTrackCallback().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTrackCallback | PlainMessage<PublishTrackCallback> | undefined, b: PublishTrackCallback | PlainMessage<PublishTrackCallback> | undefined): boolean {
    return proto2.util.equals(PublishTrackCallback, a, b);
  }
}

/**
 * Unpublish a track from the room
 *
 * @generated from message livekit.proto.UnpublishTrackRequest
 */
export class UnpublishTrackRequest extends Message<UnpublishTrackRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  /**
   * @generated from field: required bool stop_on_unpublish = 3;
   */
  stopOnUnpublish?: boolean;

  constructor(data?: PartialMessage<UnpublishTrackRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.UnpublishTrackRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "stop_on_unpublish", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UnpublishTrackRequest {
    return new UnpublishTrackRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UnpublishTrackRequest {
    return new UnpublishTrackRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UnpublishTrackRequest {
    return new UnpublishTrackRequest().fromJsonString(jsonString, options);
  }

  static equals(a: UnpublishTrackRequest | PlainMessage<UnpublishTrackRequest> | undefined, b: UnpublishTrackRequest | PlainMessage<UnpublishTrackRequest> | undefined): boolean {
    return proto2.util.equals(UnpublishTrackRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.UnpublishTrackResponse
 */
export class UnpublishTrackResponse extends Message<UnpublishTrackResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<UnpublishTrackResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.UnpublishTrackResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UnpublishTrackResponse {
    return new UnpublishTrackResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UnpublishTrackResponse {
    return new UnpublishTrackResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UnpublishTrackResponse {
    return new UnpublishTrackResponse().fromJsonString(jsonString, options);
  }

  static equals(a: UnpublishTrackResponse | PlainMessage<UnpublishTrackResponse> | undefined, b: UnpublishTrackResponse | PlainMessage<UnpublishTrackResponse> | undefined): boolean {
    return proto2.util.equals(UnpublishTrackResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.UnpublishTrackCallback
 */
export class UnpublishTrackCallback extends Message<UnpublishTrackCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<UnpublishTrackCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.UnpublishTrackCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UnpublishTrackCallback {
    return new UnpublishTrackCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UnpublishTrackCallback {
    return new UnpublishTrackCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UnpublishTrackCallback {
    return new UnpublishTrackCallback().fromJsonString(jsonString, options);
  }

  static equals(a: UnpublishTrackCallback | PlainMessage<UnpublishTrackCallback> | undefined, b: UnpublishTrackCallback | PlainMessage<UnpublishTrackCallback> | undefined): boolean {
    return proto2.util.equals(UnpublishTrackCallback, a, b);
  }
}

/**
 * Publish data to other participants
 *
 * @generated from message livekit.proto.PublishDataRequest
 */
export class PublishDataRequest extends Message<PublishDataRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required uint64 data_ptr = 2;
   */
  dataPtr?: bigint;

  /**
   * @generated from field: required uint64 data_len = 3;
   */
  dataLen?: bigint;

  /**
   * @generated from field: required bool reliable = 4;
   */
  reliable?: boolean;

  /**
   * @generated from field: repeated string destination_sids = 5 [deprecated = true];
   * @deprecated
   */
  destinationSids: string[] = [];

  /**
   * @generated from field: optional string topic = 6;
   */
  topic?: string;

  /**
   * @generated from field: repeated string destination_identities = 7;
   */
  destinationIdentities: string[] = [];

  constructor(data?: PartialMessage<PublishDataRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishDataRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "data_len", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 4, name: "reliable", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 5, name: "destination_sids", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 6, name: "topic", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 7, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishDataRequest {
    return new PublishDataRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishDataRequest {
    return new PublishDataRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishDataRequest {
    return new PublishDataRequest().fromJsonString(jsonString, options);
  }

  static equals(a: PublishDataRequest | PlainMessage<PublishDataRequest> | undefined, b: PublishDataRequest | PlainMessage<PublishDataRequest> | undefined): boolean {
    return proto2.util.equals(PublishDataRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishDataResponse
 */
export class PublishDataResponse extends Message<PublishDataResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<PublishDataResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishDataResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishDataResponse {
    return new PublishDataResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishDataResponse {
    return new PublishDataResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishDataResponse {
    return new PublishDataResponse().fromJsonString(jsonString, options);
  }

  static equals(a: PublishDataResponse | PlainMessage<PublishDataResponse> | undefined, b: PublishDataResponse | PlainMessage<PublishDataResponse> | undefined): boolean {
    return proto2.util.equals(PublishDataResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishDataCallback
 */
export class PublishDataCallback extends Message<PublishDataCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<PublishDataCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishDataCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishDataCallback {
    return new PublishDataCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishDataCallback {
    return new PublishDataCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishDataCallback {
    return new PublishDataCallback().fromJsonString(jsonString, options);
  }

  static equals(a: PublishDataCallback | PlainMessage<PublishDataCallback> | undefined, b: PublishDataCallback | PlainMessage<PublishDataCallback> | undefined): boolean {
    return proto2.util.equals(PublishDataCallback, a, b);
  }
}

/**
 * Publish transcription messages to room
 *
 * @generated from message livekit.proto.PublishTranscriptionRequest
 */
export class PublishTranscriptionRequest extends Message<PublishTranscriptionRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string participant_identity = 2;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string track_id = 3;
   */
  trackId?: string;

  /**
   * @generated from field: repeated livekit.proto.TranscriptionSegment segments = 4;
   */
  segments: TranscriptionSegment[] = [];

  constructor(data?: PartialMessage<PublishTranscriptionRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTranscriptionRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "track_id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "segments", kind: "message", T: TranscriptionSegment, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTranscriptionRequest {
    return new PublishTranscriptionRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTranscriptionRequest {
    return new PublishTranscriptionRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTranscriptionRequest {
    return new PublishTranscriptionRequest().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTranscriptionRequest | PlainMessage<PublishTranscriptionRequest> | undefined, b: PublishTranscriptionRequest | PlainMessage<PublishTranscriptionRequest> | undefined): boolean {
    return proto2.util.equals(PublishTranscriptionRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishTranscriptionResponse
 */
export class PublishTranscriptionResponse extends Message<PublishTranscriptionResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<PublishTranscriptionResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTranscriptionResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTranscriptionResponse {
    return new PublishTranscriptionResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTranscriptionResponse {
    return new PublishTranscriptionResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTranscriptionResponse {
    return new PublishTranscriptionResponse().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTranscriptionResponse | PlainMessage<PublishTranscriptionResponse> | undefined, b: PublishTranscriptionResponse | PlainMessage<PublishTranscriptionResponse> | undefined): boolean {
    return proto2.util.equals(PublishTranscriptionResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishTranscriptionCallback
 */
export class PublishTranscriptionCallback extends Message<PublishTranscriptionCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<PublishTranscriptionCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishTranscriptionCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishTranscriptionCallback {
    return new PublishTranscriptionCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishTranscriptionCallback {
    return new PublishTranscriptionCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishTranscriptionCallback {
    return new PublishTranscriptionCallback().fromJsonString(jsonString, options);
  }

  static equals(a: PublishTranscriptionCallback | PlainMessage<PublishTranscriptionCallback> | undefined, b: PublishTranscriptionCallback | PlainMessage<PublishTranscriptionCallback> | undefined): boolean {
    return proto2.util.equals(PublishTranscriptionCallback, a, b);
  }
}

/**
 * Publish Sip DTMF messages to other participants
 *
 * @generated from message livekit.proto.PublishSipDtmfRequest
 */
export class PublishSipDtmfRequest extends Message<PublishSipDtmfRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required uint32 code = 2;
   */
  code?: number;

  /**
   * @generated from field: required string digit = 3;
   */
  digit?: string;

  /**
   * @generated from field: repeated string destination_identities = 4;
   */
  destinationIdentities: string[] = [];

  constructor(data?: PartialMessage<PublishSipDtmfRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishSipDtmfRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "code", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 3, name: "digit", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishSipDtmfRequest {
    return new PublishSipDtmfRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishSipDtmfRequest {
    return new PublishSipDtmfRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishSipDtmfRequest {
    return new PublishSipDtmfRequest().fromJsonString(jsonString, options);
  }

  static equals(a: PublishSipDtmfRequest | PlainMessage<PublishSipDtmfRequest> | undefined, b: PublishSipDtmfRequest | PlainMessage<PublishSipDtmfRequest> | undefined): boolean {
    return proto2.util.equals(PublishSipDtmfRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishSipDtmfResponse
 */
export class PublishSipDtmfResponse extends Message<PublishSipDtmfResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<PublishSipDtmfResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishSipDtmfResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishSipDtmfResponse {
    return new PublishSipDtmfResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishSipDtmfResponse {
    return new PublishSipDtmfResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishSipDtmfResponse {
    return new PublishSipDtmfResponse().fromJsonString(jsonString, options);
  }

  static equals(a: PublishSipDtmfResponse | PlainMessage<PublishSipDtmfResponse> | undefined, b: PublishSipDtmfResponse | PlainMessage<PublishSipDtmfResponse> | undefined): boolean {
    return proto2.util.equals(PublishSipDtmfResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.PublishSipDtmfCallback
 */
export class PublishSipDtmfCallback extends Message<PublishSipDtmfCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<PublishSipDtmfCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.PublishSipDtmfCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): PublishSipDtmfCallback {
    return new PublishSipDtmfCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): PublishSipDtmfCallback {
    return new PublishSipDtmfCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): PublishSipDtmfCallback {
    return new PublishSipDtmfCallback().fromJsonString(jsonString, options);
  }

  static equals(a: PublishSipDtmfCallback | PlainMessage<PublishSipDtmfCallback> | undefined, b: PublishSipDtmfCallback | PlainMessage<PublishSipDtmfCallback> | undefined): boolean {
    return proto2.util.equals(PublishSipDtmfCallback, a, b);
  }
}

/**
 * Change the local participant's metadata
 *
 * @generated from message livekit.proto.SetLocalMetadataRequest
 */
export class SetLocalMetadataRequest extends Message<SetLocalMetadataRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string metadata = 2;
   */
  metadata?: string;

  constructor(data?: PartialMessage<SetLocalMetadataRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalMetadataRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "metadata", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalMetadataRequest {
    return new SetLocalMetadataRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalMetadataRequest {
    return new SetLocalMetadataRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalMetadataRequest {
    return new SetLocalMetadataRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalMetadataRequest | PlainMessage<SetLocalMetadataRequest> | undefined, b: SetLocalMetadataRequest | PlainMessage<SetLocalMetadataRequest> | undefined): boolean {
    return proto2.util.equals(SetLocalMetadataRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalMetadataResponse
 */
export class SetLocalMetadataResponse extends Message<SetLocalMetadataResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SetLocalMetadataResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalMetadataResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalMetadataResponse {
    return new SetLocalMetadataResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalMetadataResponse {
    return new SetLocalMetadataResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalMetadataResponse {
    return new SetLocalMetadataResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalMetadataResponse | PlainMessage<SetLocalMetadataResponse> | undefined, b: SetLocalMetadataResponse | PlainMessage<SetLocalMetadataResponse> | undefined): boolean {
    return proto2.util.equals(SetLocalMetadataResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalMetadataCallback
 */
export class SetLocalMetadataCallback extends Message<SetLocalMetadataCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SetLocalMetadataCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalMetadataCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalMetadataCallback {
    return new SetLocalMetadataCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalMetadataCallback {
    return new SetLocalMetadataCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalMetadataCallback {
    return new SetLocalMetadataCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalMetadataCallback | PlainMessage<SetLocalMetadataCallback> | undefined, b: SetLocalMetadataCallback | PlainMessage<SetLocalMetadataCallback> | undefined): boolean {
    return proto2.util.equals(SetLocalMetadataCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendChatMessageRequest
 */
export class SendChatMessageRequest extends Message<SendChatMessageRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string message = 2;
   */
  message?: string;

  /**
   * @generated from field: repeated string destination_identities = 3;
   */
  destinationIdentities: string[] = [];

  /**
   * @generated from field: optional string sender_identity = 4;
   */
  senderIdentity?: string;

  constructor(data?: PartialMessage<SendChatMessageRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendChatMessageRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "message", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "sender_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendChatMessageRequest {
    return new SendChatMessageRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendChatMessageRequest {
    return new SendChatMessageRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendChatMessageRequest {
    return new SendChatMessageRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SendChatMessageRequest | PlainMessage<SendChatMessageRequest> | undefined, b: SendChatMessageRequest | PlainMessage<SendChatMessageRequest> | undefined): boolean {
    return proto2.util.equals(SendChatMessageRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.EditChatMessageRequest
 */
export class EditChatMessageRequest extends Message<EditChatMessageRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string edit_text = 2;
   */
  editText?: string;

  /**
   * @generated from field: required livekit.proto.ChatMessage original_message = 3;
   */
  originalMessage?: ChatMessage;

  /**
   * @generated from field: repeated string destination_identities = 4;
   */
  destinationIdentities: string[] = [];

  /**
   * @generated from field: optional string sender_identity = 5;
   */
  senderIdentity?: string;

  constructor(data?: PartialMessage<EditChatMessageRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.EditChatMessageRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "edit_text", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "original_message", kind: "message", T: ChatMessage, req: true },
    { no: 4, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 5, name: "sender_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): EditChatMessageRequest {
    return new EditChatMessageRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): EditChatMessageRequest {
    return new EditChatMessageRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): EditChatMessageRequest {
    return new EditChatMessageRequest().fromJsonString(jsonString, options);
  }

  static equals(a: EditChatMessageRequest | PlainMessage<EditChatMessageRequest> | undefined, b: EditChatMessageRequest | PlainMessage<EditChatMessageRequest> | undefined): boolean {
    return proto2.util.equals(EditChatMessageRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendChatMessageResponse
 */
export class SendChatMessageResponse extends Message<SendChatMessageResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SendChatMessageResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendChatMessageResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendChatMessageResponse {
    return new SendChatMessageResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendChatMessageResponse {
    return new SendChatMessageResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendChatMessageResponse {
    return new SendChatMessageResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SendChatMessageResponse | PlainMessage<SendChatMessageResponse> | undefined, b: SendChatMessageResponse | PlainMessage<SendChatMessageResponse> | undefined): boolean {
    return proto2.util.equals(SendChatMessageResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendChatMessageCallback
 */
export class SendChatMessageCallback extends Message<SendChatMessageCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from oneof livekit.proto.SendChatMessageCallback.message
   */
  message: {
    /**
     * @generated from field: string error = 2;
     */
    value: string;
    case: "error";
  } | {
    /**
     * @generated from field: livekit.proto.ChatMessage chat_message = 3;
     */
    value: ChatMessage;
    case: "chatMessage";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<SendChatMessageCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendChatMessageCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "message" },
    { no: 3, name: "chat_message", kind: "message", T: ChatMessage, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendChatMessageCallback {
    return new SendChatMessageCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendChatMessageCallback {
    return new SendChatMessageCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendChatMessageCallback {
    return new SendChatMessageCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SendChatMessageCallback | PlainMessage<SendChatMessageCallback> | undefined, b: SendChatMessageCallback | PlainMessage<SendChatMessageCallback> | undefined): boolean {
    return proto2.util.equals(SendChatMessageCallback, a, b);
  }
}

/**
 * Change the local participant's attributes
 *
 * @generated from message livekit.proto.SetLocalAttributesRequest
 */
export class SetLocalAttributesRequest extends Message<SetLocalAttributesRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: repeated livekit.proto.AttributesEntry attributes = 2;
   */
  attributes: AttributesEntry[] = [];

  constructor(data?: PartialMessage<SetLocalAttributesRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalAttributesRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "attributes", kind: "message", T: AttributesEntry, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalAttributesRequest {
    return new SetLocalAttributesRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalAttributesRequest {
    return new SetLocalAttributesRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalAttributesRequest {
    return new SetLocalAttributesRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalAttributesRequest | PlainMessage<SetLocalAttributesRequest> | undefined, b: SetLocalAttributesRequest | PlainMessage<SetLocalAttributesRequest> | undefined): boolean {
    return proto2.util.equals(SetLocalAttributesRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.AttributesEntry
 */
export class AttributesEntry extends Message<AttributesEntry> {
  /**
   * @generated from field: required string key = 1;
   */
  key?: string;

  /**
   * @generated from field: required string value = 2;
   */
  value?: string;

  constructor(data?: PartialMessage<AttributesEntry>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AttributesEntry";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "key", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AttributesEntry {
    return new AttributesEntry().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AttributesEntry {
    return new AttributesEntry().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AttributesEntry {
    return new AttributesEntry().fromJsonString(jsonString, options);
  }

  static equals(a: AttributesEntry | PlainMessage<AttributesEntry> | undefined, b: AttributesEntry | PlainMessage<AttributesEntry> | undefined): boolean {
    return proto2.util.equals(AttributesEntry, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalAttributesResponse
 */
export class SetLocalAttributesResponse extends Message<SetLocalAttributesResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SetLocalAttributesResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalAttributesResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalAttributesResponse {
    return new SetLocalAttributesResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalAttributesResponse {
    return new SetLocalAttributesResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalAttributesResponse {
    return new SetLocalAttributesResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalAttributesResponse | PlainMessage<SetLocalAttributesResponse> | undefined, b: SetLocalAttributesResponse | PlainMessage<SetLocalAttributesResponse> | undefined): boolean {
    return proto2.util.equals(SetLocalAttributesResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalAttributesCallback
 */
export class SetLocalAttributesCallback extends Message<SetLocalAttributesCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SetLocalAttributesCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalAttributesCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalAttributesCallback {
    return new SetLocalAttributesCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalAttributesCallback {
    return new SetLocalAttributesCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalAttributesCallback {
    return new SetLocalAttributesCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalAttributesCallback | PlainMessage<SetLocalAttributesCallback> | undefined, b: SetLocalAttributesCallback | PlainMessage<SetLocalAttributesCallback> | undefined): boolean {
    return proto2.util.equals(SetLocalAttributesCallback, a, b);
  }
}

/**
 * Change the local participant's name
 *
 * @generated from message livekit.proto.SetLocalNameRequest
 */
export class SetLocalNameRequest extends Message<SetLocalNameRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required string name = 2;
   */
  name?: string;

  constructor(data?: PartialMessage<SetLocalNameRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalNameRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalNameRequest {
    return new SetLocalNameRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalNameRequest {
    return new SetLocalNameRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalNameRequest {
    return new SetLocalNameRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalNameRequest | PlainMessage<SetLocalNameRequest> | undefined, b: SetLocalNameRequest | PlainMessage<SetLocalNameRequest> | undefined): boolean {
    return proto2.util.equals(SetLocalNameRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalNameResponse
 */
export class SetLocalNameResponse extends Message<SetLocalNameResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SetLocalNameResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalNameResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalNameResponse {
    return new SetLocalNameResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalNameResponse {
    return new SetLocalNameResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalNameResponse {
    return new SetLocalNameResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalNameResponse | PlainMessage<SetLocalNameResponse> | undefined, b: SetLocalNameResponse | PlainMessage<SetLocalNameResponse> | undefined): boolean {
    return proto2.util.equals(SetLocalNameResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetLocalNameCallback
 */
export class SetLocalNameCallback extends Message<SetLocalNameCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SetLocalNameCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetLocalNameCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetLocalNameCallback {
    return new SetLocalNameCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetLocalNameCallback {
    return new SetLocalNameCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetLocalNameCallback {
    return new SetLocalNameCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SetLocalNameCallback | PlainMessage<SetLocalNameCallback> | undefined, b: SetLocalNameCallback | PlainMessage<SetLocalNameCallback> | undefined): boolean {
    return proto2.util.equals(SetLocalNameCallback, a, b);
  }
}

/**
 * Change the "desire" to subs2ribe to a track
 *
 * @generated from message livekit.proto.SetSubscribedRequest
 */
export class SetSubscribedRequest extends Message<SetSubscribedRequest> {
  /**
   * @generated from field: required bool subscribe = 1;
   */
  subscribe?: boolean;

  /**
   * @generated from field: required uint64 publication_handle = 2;
   */
  publicationHandle?: bigint;

  constructor(data?: PartialMessage<SetSubscribedRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetSubscribedRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "subscribe", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 2, name: "publication_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetSubscribedRequest {
    return new SetSubscribedRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetSubscribedRequest {
    return new SetSubscribedRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetSubscribedRequest {
    return new SetSubscribedRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SetSubscribedRequest | PlainMessage<SetSubscribedRequest> | undefined, b: SetSubscribedRequest | PlainMessage<SetSubscribedRequest> | undefined): boolean {
    return proto2.util.equals(SetSubscribedRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetSubscribedResponse
 */
export class SetSubscribedResponse extends Message<SetSubscribedResponse> {
  constructor(data?: PartialMessage<SetSubscribedResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetSubscribedResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetSubscribedResponse {
    return new SetSubscribedResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetSubscribedResponse {
    return new SetSubscribedResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetSubscribedResponse {
    return new SetSubscribedResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SetSubscribedResponse | PlainMessage<SetSubscribedResponse> | undefined, b: SetSubscribedResponse | PlainMessage<SetSubscribedResponse> | undefined): boolean {
    return proto2.util.equals(SetSubscribedResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.GetSessionStatsRequest
 */
export class GetSessionStatsRequest extends Message<GetSessionStatsRequest> {
  /**
   * @generated from field: required uint64 room_handle = 1;
   */
  roomHandle?: bigint;

  constructor(data?: PartialMessage<GetSessionStatsRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.GetSessionStatsRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "room_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): GetSessionStatsRequest {
    return new GetSessionStatsRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): GetSessionStatsRequest {
    return new GetSessionStatsRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): GetSessionStatsRequest {
    return new GetSessionStatsRequest().fromJsonString(jsonString, options);
  }

  static equals(a: GetSessionStatsRequest | PlainMessage<GetSessionStatsRequest> | undefined, b: GetSessionStatsRequest | PlainMessage<GetSessionStatsRequest> | undefined): boolean {
    return proto2.util.equals(GetSessionStatsRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.GetSessionStatsResponse
 */
export class GetSessionStatsResponse extends Message<GetSessionStatsResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<GetSessionStatsResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.GetSessionStatsResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): GetSessionStatsResponse {
    return new GetSessionStatsResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): GetSessionStatsResponse {
    return new GetSessionStatsResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): GetSessionStatsResponse {
    return new GetSessionStatsResponse().fromJsonString(jsonString, options);
  }

  static equals(a: GetSessionStatsResponse | PlainMessage<GetSessionStatsResponse> | undefined, b: GetSessionStatsResponse | PlainMessage<GetSessionStatsResponse> | undefined): boolean {
    return proto2.util.equals(GetSessionStatsResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.GetSessionStatsCallback
 */
export class GetSessionStatsCallback extends Message<GetSessionStatsCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from oneof livekit.proto.GetSessionStatsCallback.message
   */
  message: {
    /**
     * @generated from field: string error = 2;
     */
    value: string;
    case: "error";
  } | {
    /**
     * @generated from field: livekit.proto.GetSessionStatsCallback.Result result = 3;
     */
    value: GetSessionStatsCallback_Result;
    case: "result";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<GetSessionStatsCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.GetSessionStatsCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "message" },
    { no: 3, name: "result", kind: "message", T: GetSessionStatsCallback_Result, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): GetSessionStatsCallback {
    return new GetSessionStatsCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): GetSessionStatsCallback {
    return new GetSessionStatsCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): GetSessionStatsCallback {
    return new GetSessionStatsCallback().fromJsonString(jsonString, options);
  }

  static equals(a: GetSessionStatsCallback | PlainMessage<GetSessionStatsCallback> | undefined, b: GetSessionStatsCallback | PlainMessage<GetSessionStatsCallback> | undefined): boolean {
    return proto2.util.equals(GetSessionStatsCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.GetSessionStatsCallback.Result
 */
export class GetSessionStatsCallback_Result extends Message<GetSessionStatsCallback_Result> {
  /**
   * @generated from field: repeated livekit.proto.RtcStats publisher_stats = 1;
   */
  publisherStats: RtcStats[] = [];

  /**
   * @generated from field: repeated livekit.proto.RtcStats subscriber_stats = 2;
   */
  subscriberStats: RtcStats[] = [];

  constructor(data?: PartialMessage<GetSessionStatsCallback_Result>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.GetSessionStatsCallback.Result";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "publisher_stats", kind: "message", T: RtcStats, repeated: true },
    { no: 2, name: "subscriber_stats", kind: "message", T: RtcStats, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): GetSessionStatsCallback_Result {
    return new GetSessionStatsCallback_Result().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): GetSessionStatsCallback_Result {
    return new GetSessionStatsCallback_Result().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): GetSessionStatsCallback_Result {
    return new GetSessionStatsCallback_Result().fromJsonString(jsonString, options);
  }

  static equals(a: GetSessionStatsCallback_Result | PlainMessage<GetSessionStatsCallback_Result> | undefined, b: GetSessionStatsCallback_Result | PlainMessage<GetSessionStatsCallback_Result> | undefined): boolean {
    return proto2.util.equals(GetSessionStatsCallback_Result, a, b);
  }
}

/**
 * @generated from message livekit.proto.VideoEncoding
 */
export class VideoEncoding extends Message<VideoEncoding> {
  /**
   * @generated from field: required uint64 max_bitrate = 1;
   */
  maxBitrate?: bigint;

  /**
   * @generated from field: required double max_framerate = 2;
   */
  maxFramerate?: number;

  constructor(data?: PartialMessage<VideoEncoding>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.VideoEncoding";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "max_bitrate", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "max_framerate", kind: "scalar", T: 1 /* ScalarType.DOUBLE */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): VideoEncoding {
    return new VideoEncoding().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): VideoEncoding {
    return new VideoEncoding().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): VideoEncoding {
    return new VideoEncoding().fromJsonString(jsonString, options);
  }

  static equals(a: VideoEncoding | PlainMessage<VideoEncoding> | undefined, b: VideoEncoding | PlainMessage<VideoEncoding> | undefined): boolean {
    return proto2.util.equals(VideoEncoding, a, b);
  }
}

/**
 * @generated from message livekit.proto.AudioEncoding
 */
export class AudioEncoding extends Message<AudioEncoding> {
  /**
   * @generated from field: required uint64 max_bitrate = 1;
   */
  maxBitrate?: bigint;

  constructor(data?: PartialMessage<AudioEncoding>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.AudioEncoding";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "max_bitrate", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): AudioEncoding {
    return new AudioEncoding().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): AudioEncoding {
    return new AudioEncoding().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): AudioEncoding {
    return new AudioEncoding().fromJsonString(jsonString, options);
  }

  static equals(a: AudioEncoding | PlainMessage<AudioEncoding> | undefined, b: AudioEncoding | PlainMessage<AudioEncoding> | undefined): boolean {
    return proto2.util.equals(AudioEncoding, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackPublishOptions
 */
export class TrackPublishOptions extends Message<TrackPublishOptions> {
  /**
   * encodings are optional
   *
   * @generated from field: optional livekit.proto.VideoEncoding video_encoding = 1;
   */
  videoEncoding?: VideoEncoding;

  /**
   * @generated from field: optional livekit.proto.AudioEncoding audio_encoding = 2;
   */
  audioEncoding?: AudioEncoding;

  /**
   * @generated from field: optional livekit.proto.VideoCodec video_codec = 3;
   */
  videoCodec?: VideoCodec;

  /**
   * @generated from field: optional bool dtx = 4;
   */
  dtx?: boolean;

  /**
   * @generated from field: optional bool red = 5;
   */
  red?: boolean;

  /**
   * @generated from field: optional bool simulcast = 6;
   */
  simulcast?: boolean;

  /**
   * @generated from field: optional livekit.proto.TrackSource source = 7;
   */
  source?: TrackSource;

  /**
   * @generated from field: optional string stream = 8;
   */
  stream?: string;

  constructor(data?: PartialMessage<TrackPublishOptions>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackPublishOptions";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "video_encoding", kind: "message", T: VideoEncoding, opt: true },
    { no: 2, name: "audio_encoding", kind: "message", T: AudioEncoding, opt: true },
    { no: 3, name: "video_codec", kind: "enum", T: proto2.getEnumType(VideoCodec), opt: true },
    { no: 4, name: "dtx", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 5, name: "red", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 6, name: "simulcast", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 7, name: "source", kind: "enum", T: proto2.getEnumType(TrackSource), opt: true },
    { no: 8, name: "stream", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackPublishOptions {
    return new TrackPublishOptions().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackPublishOptions {
    return new TrackPublishOptions().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackPublishOptions {
    return new TrackPublishOptions().fromJsonString(jsonString, options);
  }

  static equals(a: TrackPublishOptions | PlainMessage<TrackPublishOptions> | undefined, b: TrackPublishOptions | PlainMessage<TrackPublishOptions> | undefined): boolean {
    return proto2.util.equals(TrackPublishOptions, a, b);
  }
}

/**
 * @generated from message livekit.proto.IceServer
 */
export class IceServer extends Message<IceServer> {
  /**
   * @generated from field: repeated string urls = 1;
   */
  urls: string[] = [];

  /**
   * @generated from field: optional string username = 2;
   */
  username?: string;

  /**
   * @generated from field: optional string password = 3;
   */
  password?: string;

  constructor(data?: PartialMessage<IceServer>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.IceServer";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "urls", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 2, name: "username", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "password", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): IceServer {
    return new IceServer().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): IceServer {
    return new IceServer().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): IceServer {
    return new IceServer().fromJsonString(jsonString, options);
  }

  static equals(a: IceServer | PlainMessage<IceServer> | undefined, b: IceServer | PlainMessage<IceServer> | undefined): boolean {
    return proto2.util.equals(IceServer, a, b);
  }
}

/**
 * @generated from message livekit.proto.RtcConfig
 */
export class RtcConfig extends Message<RtcConfig> {
  /**
   * @generated from field: optional livekit.proto.IceTransportType ice_transport_type = 1;
   */
  iceTransportType?: IceTransportType;

  /**
   * @generated from field: optional livekit.proto.ContinualGatheringPolicy continual_gathering_policy = 2;
   */
  continualGatheringPolicy?: ContinualGatheringPolicy;

  /**
   * empty fallback to default
   *
   * @generated from field: repeated livekit.proto.IceServer ice_servers = 3;
   */
  iceServers: IceServer[] = [];

  constructor(data?: PartialMessage<RtcConfig>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RtcConfig";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "ice_transport_type", kind: "enum", T: proto2.getEnumType(IceTransportType), opt: true },
    { no: 2, name: "continual_gathering_policy", kind: "enum", T: proto2.getEnumType(ContinualGatheringPolicy), opt: true },
    { no: 3, name: "ice_servers", kind: "message", T: IceServer, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RtcConfig {
    return new RtcConfig().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RtcConfig {
    return new RtcConfig().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RtcConfig {
    return new RtcConfig().fromJsonString(jsonString, options);
  }

  static equals(a: RtcConfig | PlainMessage<RtcConfig> | undefined, b: RtcConfig | PlainMessage<RtcConfig> | undefined): boolean {
    return proto2.util.equals(RtcConfig, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomOptions
 */
export class RoomOptions extends Message<RoomOptions> {
  /**
   * @generated from field: optional bool auto_subscribe = 1;
   */
  autoSubscribe?: boolean;

  /**
   * @generated from field: optional bool adaptive_stream = 2;
   */
  adaptiveStream?: boolean;

  /**
   * @generated from field: optional bool dynacast = 3;
   */
  dynacast?: boolean;

  /**
   * @generated from field: optional livekit.proto.E2eeOptions e2ee = 4;
   */
  e2ee?: E2eeOptions;

  /**
   * allow to setup a custom RtcConfiguration
   *
   * @generated from field: optional livekit.proto.RtcConfig rtc_config = 5;
   */
  rtcConfig?: RtcConfig;

  /**
   * @generated from field: optional uint32 join_retries = 6;
   */
  joinRetries?: number;

  constructor(data?: PartialMessage<RoomOptions>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomOptions";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "auto_subscribe", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 2, name: "adaptive_stream", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 3, name: "dynacast", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 4, name: "e2ee", kind: "message", T: E2eeOptions, opt: true },
    { no: 5, name: "rtc_config", kind: "message", T: RtcConfig, opt: true },
    { no: 6, name: "join_retries", kind: "scalar", T: 13 /* ScalarType.UINT32 */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomOptions {
    return new RoomOptions().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomOptions {
    return new RoomOptions().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomOptions {
    return new RoomOptions().fromJsonString(jsonString, options);
  }

  static equals(a: RoomOptions | PlainMessage<RoomOptions> | undefined, b: RoomOptions | PlainMessage<RoomOptions> | undefined): boolean {
    return proto2.util.equals(RoomOptions, a, b);
  }
}

/**
 * @generated from message livekit.proto.TranscriptionSegment
 */
export class TranscriptionSegment extends Message<TranscriptionSegment> {
  /**
   * @generated from field: required string id = 1;
   */
  id?: string;

  /**
   * @generated from field: required string text = 2;
   */
  text?: string;

  /**
   * @generated from field: required uint64 start_time = 3;
   */
  startTime?: bigint;

  /**
   * @generated from field: required uint64 end_time = 4;
   */
  endTime?: bigint;

  /**
   * @generated from field: required bool final = 5;
   */
  final?: boolean;

  /**
   * @generated from field: required string language = 6;
   */
  language?: string;

  constructor(data?: PartialMessage<TranscriptionSegment>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TranscriptionSegment";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "text", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "start_time", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 4, name: "end_time", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 5, name: "final", kind: "scalar", T: 8 /* ScalarType.BOOL */, req: true },
    { no: 6, name: "language", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TranscriptionSegment {
    return new TranscriptionSegment().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TranscriptionSegment {
    return new TranscriptionSegment().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TranscriptionSegment {
    return new TranscriptionSegment().fromJsonString(jsonString, options);
  }

  static equals(a: TranscriptionSegment | PlainMessage<TranscriptionSegment> | undefined, b: TranscriptionSegment | PlainMessage<TranscriptionSegment> | undefined): boolean {
    return proto2.util.equals(TranscriptionSegment, a, b);
  }
}

/**
 * @generated from message livekit.proto.BufferInfo
 */
export class BufferInfo extends Message<BufferInfo> {
  /**
   * @generated from field: required uint64 data_ptr = 1;
   */
  dataPtr?: bigint;

  /**
   * @generated from field: required uint64 data_len = 2;
   */
  dataLen?: bigint;

  constructor(data?: PartialMessage<BufferInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.BufferInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "data_ptr", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "data_len", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): BufferInfo {
    return new BufferInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): BufferInfo {
    return new BufferInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): BufferInfo {
    return new BufferInfo().fromJsonString(jsonString, options);
  }

  static equals(a: BufferInfo | PlainMessage<BufferInfo> | undefined, b: BufferInfo | PlainMessage<BufferInfo> | undefined): boolean {
    return proto2.util.equals(BufferInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedBuffer
 */
export class OwnedBuffer extends Message<OwnedBuffer> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.BufferInfo data = 2;
   */
  data?: BufferInfo;

  constructor(data?: PartialMessage<OwnedBuffer>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedBuffer";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "data", kind: "message", T: BufferInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedBuffer {
    return new OwnedBuffer().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedBuffer {
    return new OwnedBuffer().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedBuffer {
    return new OwnedBuffer().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedBuffer | PlainMessage<OwnedBuffer> | undefined, b: OwnedBuffer | PlainMessage<OwnedBuffer> | undefined): boolean {
    return proto2.util.equals(OwnedBuffer, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomEvent
 */
export class RoomEvent extends Message<RoomEvent> {
  /**
   * @generated from field: required uint64 room_handle = 1;
   */
  roomHandle?: bigint;

  /**
   * @generated from oneof livekit.proto.RoomEvent.message
   */
  message: {
    /**
     * @generated from field: livekit.proto.ParticipantConnected participant_connected = 2;
     */
    value: ParticipantConnected;
    case: "participantConnected";
  } | {
    /**
     * @generated from field: livekit.proto.ParticipantDisconnected participant_disconnected = 3;
     */
    value: ParticipantDisconnected;
    case: "participantDisconnected";
  } | {
    /**
     * @generated from field: livekit.proto.LocalTrackPublished local_track_published = 4;
     */
    value: LocalTrackPublished;
    case: "localTrackPublished";
  } | {
    /**
     * @generated from field: livekit.proto.LocalTrackUnpublished local_track_unpublished = 5;
     */
    value: LocalTrackUnpublished;
    case: "localTrackUnpublished";
  } | {
    /**
     * @generated from field: livekit.proto.LocalTrackSubscribed local_track_subscribed = 6;
     */
    value: LocalTrackSubscribed;
    case: "localTrackSubscribed";
  } | {
    /**
     * @generated from field: livekit.proto.TrackPublished track_published = 7;
     */
    value: TrackPublished;
    case: "trackPublished";
  } | {
    /**
     * @generated from field: livekit.proto.TrackUnpublished track_unpublished = 8;
     */
    value: TrackUnpublished;
    case: "trackUnpublished";
  } | {
    /**
     * @generated from field: livekit.proto.TrackSubscribed track_subscribed = 9;
     */
    value: TrackSubscribed;
    case: "trackSubscribed";
  } | {
    /**
     * @generated from field: livekit.proto.TrackUnsubscribed track_unsubscribed = 10;
     */
    value: TrackUnsubscribed;
    case: "trackUnsubscribed";
  } | {
    /**
     * @generated from field: livekit.proto.TrackSubscriptionFailed track_subscription_failed = 11;
     */
    value: TrackSubscriptionFailed;
    case: "trackSubscriptionFailed";
  } | {
    /**
     * @generated from field: livekit.proto.TrackMuted track_muted = 12;
     */
    value: TrackMuted;
    case: "trackMuted";
  } | {
    /**
     * @generated from field: livekit.proto.TrackUnmuted track_unmuted = 13;
     */
    value: TrackUnmuted;
    case: "trackUnmuted";
  } | {
    /**
     * @generated from field: livekit.proto.ActiveSpeakersChanged active_speakers_changed = 14;
     */
    value: ActiveSpeakersChanged;
    case: "activeSpeakersChanged";
  } | {
    /**
     * @generated from field: livekit.proto.RoomMetadataChanged room_metadata_changed = 15;
     */
    value: RoomMetadataChanged;
    case: "roomMetadataChanged";
  } | {
    /**
     * @generated from field: livekit.proto.RoomSidChanged room_sid_changed = 16;
     */
    value: RoomSidChanged;
    case: "roomSidChanged";
  } | {
    /**
     * @generated from field: livekit.proto.ParticipantMetadataChanged participant_metadata_changed = 17;
     */
    value: ParticipantMetadataChanged;
    case: "participantMetadataChanged";
  } | {
    /**
     * @generated from field: livekit.proto.ParticipantNameChanged participant_name_changed = 18;
     */
    value: ParticipantNameChanged;
    case: "participantNameChanged";
  } | {
    /**
     * @generated from field: livekit.proto.ParticipantAttributesChanged participant_attributes_changed = 19;
     */
    value: ParticipantAttributesChanged;
    case: "participantAttributesChanged";
  } | {
    /**
     * @generated from field: livekit.proto.ConnectionQualityChanged connection_quality_changed = 20;
     */
    value: ConnectionQualityChanged;
    case: "connectionQualityChanged";
  } | {
    /**
     * @generated from field: livekit.proto.ConnectionStateChanged connection_state_changed = 21;
     */
    value: ConnectionStateChanged;
    case: "connectionStateChanged";
  } | {
    /**
     * Connected connected = 21;
     *
     * @generated from field: livekit.proto.Disconnected disconnected = 22;
     */
    value: Disconnected;
    case: "disconnected";
  } | {
    /**
     * @generated from field: livekit.proto.Reconnecting reconnecting = 23;
     */
    value: Reconnecting;
    case: "reconnecting";
  } | {
    /**
     * @generated from field: livekit.proto.Reconnected reconnected = 24;
     */
    value: Reconnected;
    case: "reconnected";
  } | {
    /**
     * @generated from field: livekit.proto.E2eeStateChanged e2ee_state_changed = 25;
     */
    value: E2eeStateChanged;
    case: "e2eeStateChanged";
  } | {
    /**
     * The stream of room events has ended
     *
     * @generated from field: livekit.proto.RoomEOS eos = 26;
     */
    value: RoomEOS;
    case: "eos";
  } | {
    /**
     * @generated from field: livekit.proto.DataPacketReceived data_packet_received = 27;
     */
    value: DataPacketReceived;
    case: "dataPacketReceived";
  } | {
    /**
     * @generated from field: livekit.proto.TranscriptionReceived transcription_received = 28;
     */
    value: TranscriptionReceived;
    case: "transcriptionReceived";
  } | {
    /**
     * @generated from field: livekit.proto.ChatMessageReceived chat_message = 29;
     */
    value: ChatMessageReceived;
    case: "chatMessage";
  } | {
    /**
     * @generated from field: livekit.proto.DataStreamHeaderReceived stream_header_received = 30;
     */
    value: DataStreamHeaderReceived;
    case: "streamHeaderReceived";
  } | {
    /**
     * @generated from field: livekit.proto.DataStreamChunkReceived stream_chunk_received = 31;
     */
    value: DataStreamChunkReceived;
    case: "streamChunkReceived";
  } | {
    /**
     * @generated from field: livekit.proto.DataStreamTrailerReceived stream_trailer_received = 32;
     */
    value: DataStreamTrailerReceived;
    case: "streamTrailerReceived";
  } | {
    /**
     * @generated from field: livekit.proto.DataChannelBufferedAmountLowThresholdChanged data_channel_low_threshold_changed = 33;
     */
    value: DataChannelBufferedAmountLowThresholdChanged;
    case: "dataChannelLowThresholdChanged";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<RoomEvent>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomEvent";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "room_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "participant_connected", kind: "message", T: ParticipantConnected, oneof: "message" },
    { no: 3, name: "participant_disconnected", kind: "message", T: ParticipantDisconnected, oneof: "message" },
    { no: 4, name: "local_track_published", kind: "message", T: LocalTrackPublished, oneof: "message" },
    { no: 5, name: "local_track_unpublished", kind: "message", T: LocalTrackUnpublished, oneof: "message" },
    { no: 6, name: "local_track_subscribed", kind: "message", T: LocalTrackSubscribed, oneof: "message" },
    { no: 7, name: "track_published", kind: "message", T: TrackPublished, oneof: "message" },
    { no: 8, name: "track_unpublished", kind: "message", T: TrackUnpublished, oneof: "message" },
    { no: 9, name: "track_subscribed", kind: "message", T: TrackSubscribed, oneof: "message" },
    { no: 10, name: "track_unsubscribed", kind: "message", T: TrackUnsubscribed, oneof: "message" },
    { no: 11, name: "track_subscription_failed", kind: "message", T: TrackSubscriptionFailed, oneof: "message" },
    { no: 12, name: "track_muted", kind: "message", T: TrackMuted, oneof: "message" },
    { no: 13, name: "track_unmuted", kind: "message", T: TrackUnmuted, oneof: "message" },
    { no: 14, name: "active_speakers_changed", kind: "message", T: ActiveSpeakersChanged, oneof: "message" },
    { no: 15, name: "room_metadata_changed", kind: "message", T: RoomMetadataChanged, oneof: "message" },
    { no: 16, name: "room_sid_changed", kind: "message", T: RoomSidChanged, oneof: "message" },
    { no: 17, name: "participant_metadata_changed", kind: "message", T: ParticipantMetadataChanged, oneof: "message" },
    { no: 18, name: "participant_name_changed", kind: "message", T: ParticipantNameChanged, oneof: "message" },
    { no: 19, name: "participant_attributes_changed", kind: "message", T: ParticipantAttributesChanged, oneof: "message" },
    { no: 20, name: "connection_quality_changed", kind: "message", T: ConnectionQualityChanged, oneof: "message" },
    { no: 21, name: "connection_state_changed", kind: "message", T: ConnectionStateChanged, oneof: "message" },
    { no: 22, name: "disconnected", kind: "message", T: Disconnected, oneof: "message" },
    { no: 23, name: "reconnecting", kind: "message", T: Reconnecting, oneof: "message" },
    { no: 24, name: "reconnected", kind: "message", T: Reconnected, oneof: "message" },
    { no: 25, name: "e2ee_state_changed", kind: "message", T: E2eeStateChanged, oneof: "message" },
    { no: 26, name: "eos", kind: "message", T: RoomEOS, oneof: "message" },
    { no: 27, name: "data_packet_received", kind: "message", T: DataPacketReceived, oneof: "message" },
    { no: 28, name: "transcription_received", kind: "message", T: TranscriptionReceived, oneof: "message" },
    { no: 29, name: "chat_message", kind: "message", T: ChatMessageReceived, oneof: "message" },
    { no: 30, name: "stream_header_received", kind: "message", T: DataStreamHeaderReceived, oneof: "message" },
    { no: 31, name: "stream_chunk_received", kind: "message", T: DataStreamChunkReceived, oneof: "message" },
    { no: 32, name: "stream_trailer_received", kind: "message", T: DataStreamTrailerReceived, oneof: "message" },
    { no: 33, name: "data_channel_low_threshold_changed", kind: "message", T: DataChannelBufferedAmountLowThresholdChanged, oneof: "message" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomEvent {
    return new RoomEvent().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomEvent {
    return new RoomEvent().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomEvent {
    return new RoomEvent().fromJsonString(jsonString, options);
  }

  static equals(a: RoomEvent | PlainMessage<RoomEvent> | undefined, b: RoomEvent | PlainMessage<RoomEvent> | undefined): boolean {
    return proto2.util.equals(RoomEvent, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomInfo
 */
export class RoomInfo extends Message<RoomInfo> {
  /**
   * @generated from field: optional string sid = 1;
   */
  sid?: string;

  /**
   * @generated from field: required string name = 2;
   */
  name?: string;

  /**
   * @generated from field: required string metadata = 3;
   */
  metadata?: string;

  /**
   * @generated from field: required uint64 lossy_dc_buffered_amount_low_threshold = 4;
   */
  lossyDcBufferedAmountLowThreshold?: bigint;

  /**
   * @generated from field: required uint64 reliable_dc_buffered_amount_low_threshold = 5;
   */
  reliableDcBufferedAmountLowThreshold?: bigint;

  constructor(data?: PartialMessage<RoomInfo>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomInfo";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "sid", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "metadata", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "lossy_dc_buffered_amount_low_threshold", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 5, name: "reliable_dc_buffered_amount_low_threshold", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomInfo {
    return new RoomInfo().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomInfo {
    return new RoomInfo().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomInfo {
    return new RoomInfo().fromJsonString(jsonString, options);
  }

  static equals(a: RoomInfo | PlainMessage<RoomInfo> | undefined, b: RoomInfo | PlainMessage<RoomInfo> | undefined): boolean {
    return proto2.util.equals(RoomInfo, a, b);
  }
}

/**
 * @generated from message livekit.proto.OwnedRoom
 */
export class OwnedRoom extends Message<OwnedRoom> {
  /**
   * @generated from field: required livekit.proto.FfiOwnedHandle handle = 1;
   */
  handle?: FfiOwnedHandle;

  /**
   * @generated from field: required livekit.proto.RoomInfo info = 2;
   */
  info?: RoomInfo;

  constructor(data?: PartialMessage<OwnedRoom>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.OwnedRoom";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "handle", kind: "message", T: FfiOwnedHandle, req: true },
    { no: 2, name: "info", kind: "message", T: RoomInfo, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): OwnedRoom {
    return new OwnedRoom().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): OwnedRoom {
    return new OwnedRoom().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): OwnedRoom {
    return new OwnedRoom().fromJsonString(jsonString, options);
  }

  static equals(a: OwnedRoom | PlainMessage<OwnedRoom> | undefined, b: OwnedRoom | PlainMessage<OwnedRoom> | undefined): boolean {
    return proto2.util.equals(OwnedRoom, a, b);
  }
}

/**
 * @generated from message livekit.proto.ParticipantConnected
 */
export class ParticipantConnected extends Message<ParticipantConnected> {
  /**
   * @generated from field: required livekit.proto.OwnedParticipant info = 1;
   */
  info?: OwnedParticipant;

  constructor(data?: PartialMessage<ParticipantConnected>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ParticipantConnected";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "info", kind: "message", T: OwnedParticipant, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantConnected {
    return new ParticipantConnected().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantConnected {
    return new ParticipantConnected().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantConnected {
    return new ParticipantConnected().fromJsonString(jsonString, options);
  }

  static equals(a: ParticipantConnected | PlainMessage<ParticipantConnected> | undefined, b: ParticipantConnected | PlainMessage<ParticipantConnected> | undefined): boolean {
    return proto2.util.equals(ParticipantConnected, a, b);
  }
}

/**
 * @generated from message livekit.proto.ParticipantDisconnected
 */
export class ParticipantDisconnected extends Message<ParticipantDisconnected> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.DisconnectReason disconnect_reason = 2;
   */
  disconnectReason?: DisconnectReason;

  constructor(data?: PartialMessage<ParticipantDisconnected>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ParticipantDisconnected";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "disconnect_reason", kind: "enum", T: proto2.getEnumType(DisconnectReason), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantDisconnected {
    return new ParticipantDisconnected().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantDisconnected {
    return new ParticipantDisconnected().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantDisconnected {
    return new ParticipantDisconnected().fromJsonString(jsonString, options);
  }

  static equals(a: ParticipantDisconnected | PlainMessage<ParticipantDisconnected> | undefined, b: ParticipantDisconnected | PlainMessage<ParticipantDisconnected> | undefined): boolean {
    return proto2.util.equals(ParticipantDisconnected, a, b);
  }
}

/**
 * @generated from message livekit.proto.LocalTrackPublished
 */
export class LocalTrackPublished extends Message<LocalTrackPublished> {
  /**
   * The TrackPublicationInfo comes from the PublishTrack response
   * and the FfiClient musts wait for it before firing this event
   *
   * @generated from field: required string track_sid = 1;
   */
  trackSid?: string;

  constructor(data?: PartialMessage<LocalTrackPublished>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.LocalTrackPublished";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): LocalTrackPublished {
    return new LocalTrackPublished().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): LocalTrackPublished {
    return new LocalTrackPublished().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): LocalTrackPublished {
    return new LocalTrackPublished().fromJsonString(jsonString, options);
  }

  static equals(a: LocalTrackPublished | PlainMessage<LocalTrackPublished> | undefined, b: LocalTrackPublished | PlainMessage<LocalTrackPublished> | undefined): boolean {
    return proto2.util.equals(LocalTrackPublished, a, b);
  }
}

/**
 * @generated from message livekit.proto.LocalTrackUnpublished
 */
export class LocalTrackUnpublished extends Message<LocalTrackUnpublished> {
  /**
   * @generated from field: required string publication_sid = 1;
   */
  publicationSid?: string;

  constructor(data?: PartialMessage<LocalTrackUnpublished>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.LocalTrackUnpublished";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "publication_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): LocalTrackUnpublished {
    return new LocalTrackUnpublished().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): LocalTrackUnpublished {
    return new LocalTrackUnpublished().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): LocalTrackUnpublished {
    return new LocalTrackUnpublished().fromJsonString(jsonString, options);
  }

  static equals(a: LocalTrackUnpublished | PlainMessage<LocalTrackUnpublished> | undefined, b: LocalTrackUnpublished | PlainMessage<LocalTrackUnpublished> | undefined): boolean {
    return proto2.util.equals(LocalTrackUnpublished, a, b);
  }
}

/**
 * @generated from message livekit.proto.LocalTrackSubscribed
 */
export class LocalTrackSubscribed extends Message<LocalTrackSubscribed> {
  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  constructor(data?: PartialMessage<LocalTrackSubscribed>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.LocalTrackSubscribed";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): LocalTrackSubscribed {
    return new LocalTrackSubscribed().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): LocalTrackSubscribed {
    return new LocalTrackSubscribed().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): LocalTrackSubscribed {
    return new LocalTrackSubscribed().fromJsonString(jsonString, options);
  }

  static equals(a: LocalTrackSubscribed | PlainMessage<LocalTrackSubscribed> | undefined, b: LocalTrackSubscribed | PlainMessage<LocalTrackSubscribed> | undefined): boolean {
    return proto2.util.equals(LocalTrackSubscribed, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackPublished
 */
export class TrackPublished extends Message<TrackPublished> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.OwnedTrackPublication publication = 2;
   */
  publication?: OwnedTrackPublication;

  constructor(data?: PartialMessage<TrackPublished>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackPublished";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "publication", kind: "message", T: OwnedTrackPublication, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackPublished {
    return new TrackPublished().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackPublished {
    return new TrackPublished().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackPublished {
    return new TrackPublished().fromJsonString(jsonString, options);
  }

  static equals(a: TrackPublished | PlainMessage<TrackPublished> | undefined, b: TrackPublished | PlainMessage<TrackPublished> | undefined): boolean {
    return proto2.util.equals(TrackPublished, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackUnpublished
 */
export class TrackUnpublished extends Message<TrackUnpublished> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string publication_sid = 2;
   */
  publicationSid?: string;

  constructor(data?: PartialMessage<TrackUnpublished>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackUnpublished";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "publication_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackUnpublished {
    return new TrackUnpublished().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackUnpublished {
    return new TrackUnpublished().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackUnpublished {
    return new TrackUnpublished().fromJsonString(jsonString, options);
  }

  static equals(a: TrackUnpublished | PlainMessage<TrackUnpublished> | undefined, b: TrackUnpublished | PlainMessage<TrackUnpublished> | undefined): boolean {
    return proto2.util.equals(TrackUnpublished, a, b);
  }
}

/**
 * Publication isn't needed for subscription events on the FFI
 * The FFI will retrieve the publication using the Track sid
 *
 * @generated from message livekit.proto.TrackSubscribed
 */
export class TrackSubscribed extends Message<TrackSubscribed> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.OwnedTrack track = 2;
   */
  track?: OwnedTrack;

  constructor(data?: PartialMessage<TrackSubscribed>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackSubscribed";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "track", kind: "message", T: OwnedTrack, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackSubscribed {
    return new TrackSubscribed().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackSubscribed {
    return new TrackSubscribed().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackSubscribed {
    return new TrackSubscribed().fromJsonString(jsonString, options);
  }

  static equals(a: TrackSubscribed | PlainMessage<TrackSubscribed> | undefined, b: TrackSubscribed | PlainMessage<TrackSubscribed> | undefined): boolean {
    return proto2.util.equals(TrackSubscribed, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackUnsubscribed
 */
export class TrackUnsubscribed extends Message<TrackUnsubscribed> {
  /**
   * The FFI language can dispose/remove the VideoSink here
   *
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  constructor(data?: PartialMessage<TrackUnsubscribed>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackUnsubscribed";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackUnsubscribed {
    return new TrackUnsubscribed().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackUnsubscribed {
    return new TrackUnsubscribed().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackUnsubscribed {
    return new TrackUnsubscribed().fromJsonString(jsonString, options);
  }

  static equals(a: TrackUnsubscribed | PlainMessage<TrackUnsubscribed> | undefined, b: TrackUnsubscribed | PlainMessage<TrackUnsubscribed> | undefined): boolean {
    return proto2.util.equals(TrackUnsubscribed, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackSubscriptionFailed
 */
export class TrackSubscriptionFailed extends Message<TrackSubscriptionFailed> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  /**
   * @generated from field: required string error = 3;
   */
  error?: string;

  constructor(data?: PartialMessage<TrackSubscriptionFailed>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackSubscriptionFailed";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackSubscriptionFailed {
    return new TrackSubscriptionFailed().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackSubscriptionFailed {
    return new TrackSubscriptionFailed().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackSubscriptionFailed {
    return new TrackSubscriptionFailed().fromJsonString(jsonString, options);
  }

  static equals(a: TrackSubscriptionFailed | PlainMessage<TrackSubscriptionFailed> | undefined, b: TrackSubscriptionFailed | PlainMessage<TrackSubscriptionFailed> | undefined): boolean {
    return proto2.util.equals(TrackSubscriptionFailed, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackMuted
 */
export class TrackMuted extends Message<TrackMuted> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  constructor(data?: PartialMessage<TrackMuted>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackMuted";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackMuted {
    return new TrackMuted().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackMuted {
    return new TrackMuted().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackMuted {
    return new TrackMuted().fromJsonString(jsonString, options);
  }

  static equals(a: TrackMuted | PlainMessage<TrackMuted> | undefined, b: TrackMuted | PlainMessage<TrackMuted> | undefined): boolean {
    return proto2.util.equals(TrackMuted, a, b);
  }
}

/**
 * @generated from message livekit.proto.TrackUnmuted
 */
export class TrackUnmuted extends Message<TrackUnmuted> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string track_sid = 2;
   */
  trackSid?: string;

  constructor(data?: PartialMessage<TrackUnmuted>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TrackUnmuted";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TrackUnmuted {
    return new TrackUnmuted().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TrackUnmuted {
    return new TrackUnmuted().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TrackUnmuted {
    return new TrackUnmuted().fromJsonString(jsonString, options);
  }

  static equals(a: TrackUnmuted | PlainMessage<TrackUnmuted> | undefined, b: TrackUnmuted | PlainMessage<TrackUnmuted> | undefined): boolean {
    return proto2.util.equals(TrackUnmuted, a, b);
  }
}

/**
 * @generated from message livekit.proto.E2eeStateChanged
 */
export class E2eeStateChanged extends Message<E2eeStateChanged> {
  /**
   * Using sid instead of identity for ffi communication
   *
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.EncryptionState state = 2;
   */
  state?: EncryptionState;

  constructor(data?: PartialMessage<E2eeStateChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.E2eeStateChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "state", kind: "enum", T: proto2.getEnumType(EncryptionState), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): E2eeStateChanged {
    return new E2eeStateChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): E2eeStateChanged {
    return new E2eeStateChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): E2eeStateChanged {
    return new E2eeStateChanged().fromJsonString(jsonString, options);
  }

  static equals(a: E2eeStateChanged | PlainMessage<E2eeStateChanged> | undefined, b: E2eeStateChanged | PlainMessage<E2eeStateChanged> | undefined): boolean {
    return proto2.util.equals(E2eeStateChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.ActiveSpeakersChanged
 */
export class ActiveSpeakersChanged extends Message<ActiveSpeakersChanged> {
  /**
   * @generated from field: repeated string participant_identities = 1;
   */
  participantIdentities: string[] = [];

  constructor(data?: PartialMessage<ActiveSpeakersChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ActiveSpeakersChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ActiveSpeakersChanged {
    return new ActiveSpeakersChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ActiveSpeakersChanged {
    return new ActiveSpeakersChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ActiveSpeakersChanged {
    return new ActiveSpeakersChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ActiveSpeakersChanged | PlainMessage<ActiveSpeakersChanged> | undefined, b: ActiveSpeakersChanged | PlainMessage<ActiveSpeakersChanged> | undefined): boolean {
    return proto2.util.equals(ActiveSpeakersChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomMetadataChanged
 */
export class RoomMetadataChanged extends Message<RoomMetadataChanged> {
  /**
   * @generated from field: required string metadata = 1;
   */
  metadata?: string;

  constructor(data?: PartialMessage<RoomMetadataChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomMetadataChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "metadata", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomMetadataChanged {
    return new RoomMetadataChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomMetadataChanged {
    return new RoomMetadataChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomMetadataChanged {
    return new RoomMetadataChanged().fromJsonString(jsonString, options);
  }

  static equals(a: RoomMetadataChanged | PlainMessage<RoomMetadataChanged> | undefined, b: RoomMetadataChanged | PlainMessage<RoomMetadataChanged> | undefined): boolean {
    return proto2.util.equals(RoomMetadataChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomSidChanged
 */
export class RoomSidChanged extends Message<RoomSidChanged> {
  /**
   * @generated from field: required string sid = 1;
   */
  sid?: string;

  constructor(data?: PartialMessage<RoomSidChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomSidChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "sid", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomSidChanged {
    return new RoomSidChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomSidChanged {
    return new RoomSidChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomSidChanged {
    return new RoomSidChanged().fromJsonString(jsonString, options);
  }

  static equals(a: RoomSidChanged | PlainMessage<RoomSidChanged> | undefined, b: RoomSidChanged | PlainMessage<RoomSidChanged> | undefined): boolean {
    return proto2.util.equals(RoomSidChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.ParticipantMetadataChanged
 */
export class ParticipantMetadataChanged extends Message<ParticipantMetadataChanged> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string metadata = 2;
   */
  metadata?: string;

  constructor(data?: PartialMessage<ParticipantMetadataChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ParticipantMetadataChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "metadata", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantMetadataChanged {
    return new ParticipantMetadataChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantMetadataChanged {
    return new ParticipantMetadataChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantMetadataChanged {
    return new ParticipantMetadataChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ParticipantMetadataChanged | PlainMessage<ParticipantMetadataChanged> | undefined, b: ParticipantMetadataChanged | PlainMessage<ParticipantMetadataChanged> | undefined): boolean {
    return proto2.util.equals(ParticipantMetadataChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.ParticipantAttributesChanged
 */
export class ParticipantAttributesChanged extends Message<ParticipantAttributesChanged> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: repeated livekit.proto.AttributesEntry attributes = 2;
   */
  attributes: AttributesEntry[] = [];

  /**
   * @generated from field: repeated livekit.proto.AttributesEntry changed_attributes = 3;
   */
  changedAttributes: AttributesEntry[] = [];

  constructor(data?: PartialMessage<ParticipantAttributesChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ParticipantAttributesChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "attributes", kind: "message", T: AttributesEntry, repeated: true },
    { no: 3, name: "changed_attributes", kind: "message", T: AttributesEntry, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantAttributesChanged {
    return new ParticipantAttributesChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantAttributesChanged {
    return new ParticipantAttributesChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantAttributesChanged {
    return new ParticipantAttributesChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ParticipantAttributesChanged | PlainMessage<ParticipantAttributesChanged> | undefined, b: ParticipantAttributesChanged | PlainMessage<ParticipantAttributesChanged> | undefined): boolean {
    return proto2.util.equals(ParticipantAttributesChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.ParticipantNameChanged
 */
export class ParticipantNameChanged extends Message<ParticipantNameChanged> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required string name = 2;
   */
  name?: string;

  constructor(data?: PartialMessage<ParticipantNameChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ParticipantNameChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ParticipantNameChanged {
    return new ParticipantNameChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ParticipantNameChanged {
    return new ParticipantNameChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ParticipantNameChanged {
    return new ParticipantNameChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ParticipantNameChanged | PlainMessage<ParticipantNameChanged> | undefined, b: ParticipantNameChanged | PlainMessage<ParticipantNameChanged> | undefined): boolean {
    return proto2.util.equals(ParticipantNameChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectionQualityChanged
 */
export class ConnectionQualityChanged extends Message<ConnectionQualityChanged> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.ConnectionQuality quality = 2;
   */
  quality?: ConnectionQuality;

  constructor(data?: PartialMessage<ConnectionQualityChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectionQualityChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "quality", kind: "enum", T: proto2.getEnumType(ConnectionQuality), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectionQualityChanged {
    return new ConnectionQualityChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectionQualityChanged {
    return new ConnectionQualityChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectionQualityChanged {
    return new ConnectionQualityChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectionQualityChanged | PlainMessage<ConnectionQualityChanged> | undefined, b: ConnectionQualityChanged | PlainMessage<ConnectionQualityChanged> | undefined): boolean {
    return proto2.util.equals(ConnectionQualityChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.UserPacket
 */
export class UserPacket extends Message<UserPacket> {
  /**
   * @generated from field: required livekit.proto.OwnedBuffer data = 1;
   */
  data?: OwnedBuffer;

  /**
   * @generated from field: optional string topic = 2;
   */
  topic?: string;

  constructor(data?: PartialMessage<UserPacket>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.UserPacket";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "data", kind: "message", T: OwnedBuffer, req: true },
    { no: 2, name: "topic", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): UserPacket {
    return new UserPacket().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): UserPacket {
    return new UserPacket().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): UserPacket {
    return new UserPacket().fromJsonString(jsonString, options);
  }

  static equals(a: UserPacket | PlainMessage<UserPacket> | undefined, b: UserPacket | PlainMessage<UserPacket> | undefined): boolean {
    return proto2.util.equals(UserPacket, a, b);
  }
}

/**
 * @generated from message livekit.proto.ChatMessage
 */
export class ChatMessage extends Message<ChatMessage> {
  /**
   * @generated from field: required string id = 1;
   */
  id?: string;

  /**
   * @generated from field: required int64 timestamp = 2;
   */
  timestamp?: bigint;

  /**
   * @generated from field: required string message = 3;
   */
  message?: string;

  /**
   * @generated from field: optional int64 edit_timestamp = 4;
   */
  editTimestamp?: bigint;

  /**
   * @generated from field: optional bool deleted = 5;
   */
  deleted?: boolean;

  /**
   * @generated from field: optional bool generated = 6;
   */
  generated?: boolean;

  constructor(data?: PartialMessage<ChatMessage>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ChatMessage";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "timestamp", kind: "scalar", T: 3 /* ScalarType.INT64 */, req: true },
    { no: 3, name: "message", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "edit_timestamp", kind: "scalar", T: 3 /* ScalarType.INT64 */, opt: true },
    { no: 5, name: "deleted", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 6, name: "generated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ChatMessage {
    return new ChatMessage().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ChatMessage {
    return new ChatMessage().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ChatMessage {
    return new ChatMessage().fromJsonString(jsonString, options);
  }

  static equals(a: ChatMessage | PlainMessage<ChatMessage> | undefined, b: ChatMessage | PlainMessage<ChatMessage> | undefined): boolean {
    return proto2.util.equals(ChatMessage, a, b);
  }
}

/**
 * @generated from message livekit.proto.ChatMessageReceived
 */
export class ChatMessageReceived extends Message<ChatMessageReceived> {
  /**
   * @generated from field: required livekit.proto.ChatMessage message = 1;
   */
  message?: ChatMessage;

  /**
   * @generated from field: required string participant_identity = 2;
   */
  participantIdentity?: string;

  constructor(data?: PartialMessage<ChatMessageReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ChatMessageReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "message", kind: "message", T: ChatMessage, req: true },
    { no: 2, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ChatMessageReceived {
    return new ChatMessageReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ChatMessageReceived {
    return new ChatMessageReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ChatMessageReceived {
    return new ChatMessageReceived().fromJsonString(jsonString, options);
  }

  static equals(a: ChatMessageReceived | PlainMessage<ChatMessageReceived> | undefined, b: ChatMessageReceived | PlainMessage<ChatMessageReceived> | undefined): boolean {
    return proto2.util.equals(ChatMessageReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.SipDTMF
 */
export class SipDTMF extends Message<SipDTMF> {
  /**
   * @generated from field: required uint32 code = 1;
   */
  code?: number;

  /**
   * @generated from field: optional string digit = 2;
   */
  digit?: string;

  constructor(data?: PartialMessage<SipDTMF>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SipDTMF";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "code", kind: "scalar", T: 13 /* ScalarType.UINT32 */, req: true },
    { no: 2, name: "digit", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SipDTMF {
    return new SipDTMF().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SipDTMF {
    return new SipDTMF().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SipDTMF {
    return new SipDTMF().fromJsonString(jsonString, options);
  }

  static equals(a: SipDTMF | PlainMessage<SipDTMF> | undefined, b: SipDTMF | PlainMessage<SipDTMF> | undefined): boolean {
    return proto2.util.equals(SipDTMF, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataPacketReceived
 */
export class DataPacketReceived extends Message<DataPacketReceived> {
  /**
   * @generated from field: required livekit.proto.DataPacketKind kind = 1;
   */
  kind?: DataPacketKind;

  /**
   * Can be empty if the data is sent a server SDK
   *
   * @generated from field: required string participant_identity = 2;
   */
  participantIdentity?: string;

  /**
   * @generated from oneof livekit.proto.DataPacketReceived.value
   */
  value: {
    /**
     * @generated from field: livekit.proto.UserPacket user = 4;
     */
    value: UserPacket;
    case: "user";
  } | {
    /**
     * @generated from field: livekit.proto.SipDTMF sip_dtmf = 5;
     */
    value: SipDTMF;
    case: "sipDtmf";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<DataPacketReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataPacketReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "kind", kind: "enum", T: proto2.getEnumType(DataPacketKind), req: true },
    { no: 2, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "user", kind: "message", T: UserPacket, oneof: "value" },
    { no: 5, name: "sip_dtmf", kind: "message", T: SipDTMF, oneof: "value" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataPacketReceived {
    return new DataPacketReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataPacketReceived {
    return new DataPacketReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataPacketReceived {
    return new DataPacketReceived().fromJsonString(jsonString, options);
  }

  static equals(a: DataPacketReceived | PlainMessage<DataPacketReceived> | undefined, b: DataPacketReceived | PlainMessage<DataPacketReceived> | undefined): boolean {
    return proto2.util.equals(DataPacketReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.TranscriptionReceived
 */
export class TranscriptionReceived extends Message<TranscriptionReceived> {
  /**
   * @generated from field: optional string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: optional string track_sid = 2;
   */
  trackSid?: string;

  /**
   * @generated from field: repeated livekit.proto.TranscriptionSegment segments = 3;
   */
  segments: TranscriptionSegment[] = [];

  constructor(data?: PartialMessage<TranscriptionReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.TranscriptionReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "track_sid", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "segments", kind: "message", T: TranscriptionSegment, repeated: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TranscriptionReceived {
    return new TranscriptionReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TranscriptionReceived {
    return new TranscriptionReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TranscriptionReceived {
    return new TranscriptionReceived().fromJsonString(jsonString, options);
  }

  static equals(a: TranscriptionReceived | PlainMessage<TranscriptionReceived> | undefined, b: TranscriptionReceived | PlainMessage<TranscriptionReceived> | undefined): boolean {
    return proto2.util.equals(TranscriptionReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.ConnectionStateChanged
 */
export class ConnectionStateChanged extends Message<ConnectionStateChanged> {
  /**
   * @generated from field: required livekit.proto.ConnectionState state = 1;
   */
  state?: ConnectionState;

  constructor(data?: PartialMessage<ConnectionStateChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.ConnectionStateChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "state", kind: "enum", T: proto2.getEnumType(ConnectionState), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ConnectionStateChanged {
    return new ConnectionStateChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ConnectionStateChanged {
    return new ConnectionStateChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ConnectionStateChanged {
    return new ConnectionStateChanged().fromJsonString(jsonString, options);
  }

  static equals(a: ConnectionStateChanged | PlainMessage<ConnectionStateChanged> | undefined, b: ConnectionStateChanged | PlainMessage<ConnectionStateChanged> | undefined): boolean {
    return proto2.util.equals(ConnectionStateChanged, a, b);
  }
}

/**
 * @generated from message livekit.proto.Connected
 */
export class Connected extends Message<Connected> {
  constructor(data?: PartialMessage<Connected>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.Connected";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Connected {
    return new Connected().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Connected {
    return new Connected().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Connected {
    return new Connected().fromJsonString(jsonString, options);
  }

  static equals(a: Connected | PlainMessage<Connected> | undefined, b: Connected | PlainMessage<Connected> | undefined): boolean {
    return proto2.util.equals(Connected, a, b);
  }
}

/**
 * @generated from message livekit.proto.Disconnected
 */
export class Disconnected extends Message<Disconnected> {
  /**
   * @generated from field: required livekit.proto.DisconnectReason reason = 1;
   */
  reason?: DisconnectReason;

  constructor(data?: PartialMessage<Disconnected>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.Disconnected";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "reason", kind: "enum", T: proto2.getEnumType(DisconnectReason), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Disconnected {
    return new Disconnected().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Disconnected {
    return new Disconnected().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Disconnected {
    return new Disconnected().fromJsonString(jsonString, options);
  }

  static equals(a: Disconnected | PlainMessage<Disconnected> | undefined, b: Disconnected | PlainMessage<Disconnected> | undefined): boolean {
    return proto2.util.equals(Disconnected, a, b);
  }
}

/**
 * @generated from message livekit.proto.Reconnecting
 */
export class Reconnecting extends Message<Reconnecting> {
  constructor(data?: PartialMessage<Reconnecting>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.Reconnecting";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Reconnecting {
    return new Reconnecting().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Reconnecting {
    return new Reconnecting().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Reconnecting {
    return new Reconnecting().fromJsonString(jsonString, options);
  }

  static equals(a: Reconnecting | PlainMessage<Reconnecting> | undefined, b: Reconnecting | PlainMessage<Reconnecting> | undefined): boolean {
    return proto2.util.equals(Reconnecting, a, b);
  }
}

/**
 * @generated from message livekit.proto.Reconnected
 */
export class Reconnected extends Message<Reconnected> {
  constructor(data?: PartialMessage<Reconnected>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.Reconnected";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Reconnected {
    return new Reconnected().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Reconnected {
    return new Reconnected().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Reconnected {
    return new Reconnected().fromJsonString(jsonString, options);
  }

  static equals(a: Reconnected | PlainMessage<Reconnected> | undefined, b: Reconnected | PlainMessage<Reconnected> | undefined): boolean {
    return proto2.util.equals(Reconnected, a, b);
  }
}

/**
 * @generated from message livekit.proto.RoomEOS
 */
export class RoomEOS extends Message<RoomEOS> {
  constructor(data?: PartialMessage<RoomEOS>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.RoomEOS";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): RoomEOS {
    return new RoomEOS().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): RoomEOS {
    return new RoomEOS().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): RoomEOS {
    return new RoomEOS().fromJsonString(jsonString, options);
  }

  static equals(a: RoomEOS | PlainMessage<RoomEOS> | undefined, b: RoomEOS | PlainMessage<RoomEOS> | undefined): boolean {
    return proto2.util.equals(RoomEOS, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStream
 */
export class DataStream extends Message<DataStream> {
  constructor(data?: PartialMessage<DataStream>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream {
    return new DataStream().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream {
    return new DataStream().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream {
    return new DataStream().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream | PlainMessage<DataStream> | undefined, b: DataStream | PlainMessage<DataStream> | undefined): boolean {
    return proto2.util.equals(DataStream, a, b);
  }
}

/**
 * enum for operation types (specific to TextHeader)
 *
 * @generated from enum livekit.proto.DataStream.OperationType
 */
export enum DataStream_OperationType {
  /**
   * @generated from enum value: CREATE = 0;
   */
  CREATE = 0,

  /**
   * @generated from enum value: UPDATE = 1;
   */
  UPDATE = 1,

  /**
   * @generated from enum value: DELETE = 2;
   */
  DELETE = 2,

  /**
   * @generated from enum value: REACTION = 3;
   */
  REACTION = 3,
}
// Retrieve enum metadata with: proto2.getEnumType(DataStream_OperationType)
proto2.util.setEnumType(DataStream_OperationType, "livekit.proto.DataStream.OperationType", [
  { no: 0, name: "CREATE" },
  { no: 1, name: "UPDATE" },
  { no: 2, name: "DELETE" },
  { no: 3, name: "REACTION" },
]);

/**
 * header properties specific to text streams
 *
 * @generated from message livekit.proto.DataStream.TextHeader
 */
export class DataStream_TextHeader extends Message<DataStream_TextHeader> {
  /**
   * @generated from field: required livekit.proto.DataStream.OperationType operation_type = 1;
   */
  operationType?: DataStream_OperationType;

  /**
   * Optional: Version for updates/edits
   *
   * @generated from field: optional int32 version = 2;
   */
  version?: number;

  /**
   * Optional: Reply to specific message
   *
   * @generated from field: optional string reply_to_stream_id = 3;
   */
  replyToStreamId?: string;

  /**
   * file attachments for text streams
   *
   * @generated from field: repeated string attached_stream_ids = 4;
   */
  attachedStreamIds: string[] = [];

  /**
   * true if the text has been generated by an agent from a participant's audio transcription
   *
   * @generated from field: optional bool generated = 5;
   */
  generated?: boolean;

  constructor(data?: PartialMessage<DataStream_TextHeader>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream.TextHeader";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "operation_type", kind: "enum", T: proto2.getEnumType(DataStream_OperationType), req: true },
    { no: 2, name: "version", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 3, name: "reply_to_stream_id", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 4, name: "attached_stream_ids", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 5, name: "generated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream_TextHeader {
    return new DataStream_TextHeader().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream_TextHeader {
    return new DataStream_TextHeader().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream_TextHeader {
    return new DataStream_TextHeader().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream_TextHeader | PlainMessage<DataStream_TextHeader> | undefined, b: DataStream_TextHeader | PlainMessage<DataStream_TextHeader> | undefined): boolean {
    return proto2.util.equals(DataStream_TextHeader, a, b);
  }
}

/**
 * header properties specific to byte or file streams
 *
 * @generated from message livekit.proto.DataStream.ByteHeader
 */
export class DataStream_ByteHeader extends Message<DataStream_ByteHeader> {
  /**
   * @generated from field: required string name = 1;
   */
  name?: string;

  constructor(data?: PartialMessage<DataStream_ByteHeader>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream.ByteHeader";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream_ByteHeader {
    return new DataStream_ByteHeader().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream_ByteHeader {
    return new DataStream_ByteHeader().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream_ByteHeader {
    return new DataStream_ByteHeader().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream_ByteHeader | PlainMessage<DataStream_ByteHeader> | undefined, b: DataStream_ByteHeader | PlainMessage<DataStream_ByteHeader> | undefined): boolean {
    return proto2.util.equals(DataStream_ByteHeader, a, b);
  }
}

/**
 * main DataStream.Header that contains a oneof for specific headers
 *
 * @generated from message livekit.proto.DataStream.Header
 */
export class DataStream_Header extends Message<DataStream_Header> {
  /**
   * unique identifier for this data stream
   *
   * @generated from field: required string stream_id = 1;
   */
  streamId?: string;

  /**
   * using int64 for Unix timestamp
   *
   * @generated from field: required int64 timestamp = 2;
   */
  timestamp?: bigint;

  /**
   * @generated from field: required string mime_type = 3;
   */
  mimeType?: string;

  /**
   * @generated from field: required string topic = 4;
   */
  topic?: string;

  /**
   * only populated for finite streams, if it's a stream of unknown size this stays empty
   *
   * @generated from field: optional uint64 total_length = 5;
   */
  totalLength?: bigint;

  /**
   * user defined attributes map that can carry additional info
   *
   * @generated from field: map<string, string> attributes = 6;
   */
  attributes: { [key: string]: string } = {};

  /**
   * oneof to choose between specific header types
   *
   * @generated from oneof livekit.proto.DataStream.Header.content_header
   */
  contentHeader: {
    /**
     * @generated from field: livekit.proto.DataStream.TextHeader text_header = 7;
     */
    value: DataStream_TextHeader;
    case: "textHeader";
  } | {
    /**
     * @generated from field: livekit.proto.DataStream.ByteHeader byte_header = 8;
     */
    value: DataStream_ByteHeader;
    case: "byteHeader";
  } | { case: undefined; value?: undefined } = { case: undefined };

  constructor(data?: PartialMessage<DataStream_Header>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream.Header";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream_id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "timestamp", kind: "scalar", T: 3 /* ScalarType.INT64 */, req: true },
    { no: 3, name: "mime_type", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 4, name: "topic", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 5, name: "total_length", kind: "scalar", T: 4 /* ScalarType.UINT64 */, opt: true },
    { no: 6, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
    { no: 7, name: "text_header", kind: "message", T: DataStream_TextHeader, oneof: "content_header" },
    { no: 8, name: "byte_header", kind: "message", T: DataStream_ByteHeader, oneof: "content_header" },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream_Header {
    return new DataStream_Header().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream_Header {
    return new DataStream_Header().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream_Header {
    return new DataStream_Header().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream_Header | PlainMessage<DataStream_Header> | undefined, b: DataStream_Header | PlainMessage<DataStream_Header> | undefined): boolean {
    return proto2.util.equals(DataStream_Header, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStream.Chunk
 */
export class DataStream_Chunk extends Message<DataStream_Chunk> {
  /**
   * unique identifier for this data stream to map it to the correct header
   *
   * @generated from field: required string stream_id = 1;
   */
  streamId?: string;

  /**
   * @generated from field: required uint64 chunk_index = 2;
   */
  chunkIndex?: bigint;

  /**
   * content as binary (bytes)
   *
   * @generated from field: required bytes content = 3;
   */
  content?: Uint8Array;

  /**
   * a version indicating that this chunk_index has been retroactively modified and the original one needs to be replaced
   *
   * @generated from field: optional int32 version = 4;
   */
  version?: number;

  /**
   * optional, initialization vector for AES-GCM encryption
   *
   * @generated from field: optional bytes iv = 5;
   */
  iv?: Uint8Array;

  constructor(data?: PartialMessage<DataStream_Chunk>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream.Chunk";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream_id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "chunk_index", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "content", kind: "scalar", T: 12 /* ScalarType.BYTES */, req: true },
    { no: 4, name: "version", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 5, name: "iv", kind: "scalar", T: 12 /* ScalarType.BYTES */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream_Chunk {
    return new DataStream_Chunk().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream_Chunk {
    return new DataStream_Chunk().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream_Chunk {
    return new DataStream_Chunk().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream_Chunk | PlainMessage<DataStream_Chunk> | undefined, b: DataStream_Chunk | PlainMessage<DataStream_Chunk> | undefined): boolean {
    return proto2.util.equals(DataStream_Chunk, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStream.Trailer
 */
export class DataStream_Trailer extends Message<DataStream_Trailer> {
  /**
   * unique identifier for this data stream
   *
   * @generated from field: required string stream_id = 1;
   */
  streamId?: string;

  /**
   * reason why the stream was closed (could contain "error" / "interrupted" / empty for expected end)
   *
   * @generated from field: required string reason = 2;
   */
  reason?: string;

  /**
   * finalizing updates for the stream, can also include additional insights for errors or endTime for transcription
   *
   * @generated from field: map<string, string> attributes = 3;
   */
  attributes: { [key: string]: string } = {};

  constructor(data?: PartialMessage<DataStream_Trailer>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStream.Trailer";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "stream_id", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "reason", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 3, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStream_Trailer {
    return new DataStream_Trailer().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStream_Trailer {
    return new DataStream_Trailer().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStream_Trailer {
    return new DataStream_Trailer().fromJsonString(jsonString, options);
  }

  static equals(a: DataStream_Trailer | PlainMessage<DataStream_Trailer> | undefined, b: DataStream_Trailer | PlainMessage<DataStream_Trailer> | undefined): boolean {
    return proto2.util.equals(DataStream_Trailer, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStreamHeaderReceived
 */
export class DataStreamHeaderReceived extends Message<DataStreamHeaderReceived> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.DataStream.Header header = 2;
   */
  header?: DataStream_Header;

  constructor(data?: PartialMessage<DataStreamHeaderReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStreamHeaderReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "header", kind: "message", T: DataStream_Header, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStreamHeaderReceived {
    return new DataStreamHeaderReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStreamHeaderReceived {
    return new DataStreamHeaderReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStreamHeaderReceived {
    return new DataStreamHeaderReceived().fromJsonString(jsonString, options);
  }

  static equals(a: DataStreamHeaderReceived | PlainMessage<DataStreamHeaderReceived> | undefined, b: DataStreamHeaderReceived | PlainMessage<DataStreamHeaderReceived> | undefined): boolean {
    return proto2.util.equals(DataStreamHeaderReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStreamChunkReceived
 */
export class DataStreamChunkReceived extends Message<DataStreamChunkReceived> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.DataStream.Chunk chunk = 2;
   */
  chunk?: DataStream_Chunk;

  constructor(data?: PartialMessage<DataStreamChunkReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStreamChunkReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "chunk", kind: "message", T: DataStream_Chunk, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStreamChunkReceived {
    return new DataStreamChunkReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStreamChunkReceived {
    return new DataStreamChunkReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStreamChunkReceived {
    return new DataStreamChunkReceived().fromJsonString(jsonString, options);
  }

  static equals(a: DataStreamChunkReceived | PlainMessage<DataStreamChunkReceived> | undefined, b: DataStreamChunkReceived | PlainMessage<DataStreamChunkReceived> | undefined): boolean {
    return proto2.util.equals(DataStreamChunkReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataStreamTrailerReceived
 */
export class DataStreamTrailerReceived extends Message<DataStreamTrailerReceived> {
  /**
   * @generated from field: required string participant_identity = 1;
   */
  participantIdentity?: string;

  /**
   * @generated from field: required livekit.proto.DataStream.Trailer trailer = 2;
   */
  trailer?: DataStream_Trailer;

  constructor(data?: PartialMessage<DataStreamTrailerReceived>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataStreamTrailerReceived";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "participant_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
    { no: 2, name: "trailer", kind: "message", T: DataStream_Trailer, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataStreamTrailerReceived {
    return new DataStreamTrailerReceived().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataStreamTrailerReceived {
    return new DataStreamTrailerReceived().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataStreamTrailerReceived {
    return new DataStreamTrailerReceived().fromJsonString(jsonString, options);
  }

  static equals(a: DataStreamTrailerReceived | PlainMessage<DataStreamTrailerReceived> | undefined, b: DataStreamTrailerReceived | PlainMessage<DataStreamTrailerReceived> | undefined): boolean {
    return proto2.util.equals(DataStreamTrailerReceived, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamHeaderRequest
 */
export class SendStreamHeaderRequest extends Message<SendStreamHeaderRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.DataStream.Header header = 2;
   */
  header?: DataStream_Header;

  /**
   * @generated from field: repeated string destination_identities = 3;
   */
  destinationIdentities: string[] = [];

  /**
   * @generated from field: required string sender_identity = 4;
   */
  senderIdentity?: string;

  constructor(data?: PartialMessage<SendStreamHeaderRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamHeaderRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "header", kind: "message", T: DataStream_Header, req: true },
    { no: 3, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "sender_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamHeaderRequest {
    return new SendStreamHeaderRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamHeaderRequest {
    return new SendStreamHeaderRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamHeaderRequest {
    return new SendStreamHeaderRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamHeaderRequest | PlainMessage<SendStreamHeaderRequest> | undefined, b: SendStreamHeaderRequest | PlainMessage<SendStreamHeaderRequest> | undefined): boolean {
    return proto2.util.equals(SendStreamHeaderRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamChunkRequest
 */
export class SendStreamChunkRequest extends Message<SendStreamChunkRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.DataStream.Chunk chunk = 2;
   */
  chunk?: DataStream_Chunk;

  /**
   * @generated from field: repeated string destination_identities = 3;
   */
  destinationIdentities: string[] = [];

  /**
   * @generated from field: required string sender_identity = 4;
   */
  senderIdentity?: string;

  constructor(data?: PartialMessage<SendStreamChunkRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamChunkRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "chunk", kind: "message", T: DataStream_Chunk, req: true },
    { no: 3, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "sender_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamChunkRequest {
    return new SendStreamChunkRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamChunkRequest {
    return new SendStreamChunkRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamChunkRequest {
    return new SendStreamChunkRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamChunkRequest | PlainMessage<SendStreamChunkRequest> | undefined, b: SendStreamChunkRequest | PlainMessage<SendStreamChunkRequest> | undefined): boolean {
    return proto2.util.equals(SendStreamChunkRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamTrailerRequest
 */
export class SendStreamTrailerRequest extends Message<SendStreamTrailerRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required livekit.proto.DataStream.Trailer trailer = 2;
   */
  trailer?: DataStream_Trailer;

  /**
   * @generated from field: repeated string destination_identities = 3;
   */
  destinationIdentities: string[] = [];

  /**
   * @generated from field: required string sender_identity = 4;
   */
  senderIdentity?: string;

  constructor(data?: PartialMessage<SendStreamTrailerRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamTrailerRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "trailer", kind: "message", T: DataStream_Trailer, req: true },
    { no: 3, name: "destination_identities", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "sender_identity", kind: "scalar", T: 9 /* ScalarType.STRING */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamTrailerRequest {
    return new SendStreamTrailerRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamTrailerRequest {
    return new SendStreamTrailerRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamTrailerRequest {
    return new SendStreamTrailerRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamTrailerRequest | PlainMessage<SendStreamTrailerRequest> | undefined, b: SendStreamTrailerRequest | PlainMessage<SendStreamTrailerRequest> | undefined): boolean {
    return proto2.util.equals(SendStreamTrailerRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamHeaderResponse
 */
export class SendStreamHeaderResponse extends Message<SendStreamHeaderResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SendStreamHeaderResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamHeaderResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamHeaderResponse {
    return new SendStreamHeaderResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamHeaderResponse {
    return new SendStreamHeaderResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamHeaderResponse {
    return new SendStreamHeaderResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamHeaderResponse | PlainMessage<SendStreamHeaderResponse> | undefined, b: SendStreamHeaderResponse | PlainMessage<SendStreamHeaderResponse> | undefined): boolean {
    return proto2.util.equals(SendStreamHeaderResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamChunkResponse
 */
export class SendStreamChunkResponse extends Message<SendStreamChunkResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SendStreamChunkResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamChunkResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamChunkResponse {
    return new SendStreamChunkResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamChunkResponse {
    return new SendStreamChunkResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamChunkResponse {
    return new SendStreamChunkResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamChunkResponse | PlainMessage<SendStreamChunkResponse> | undefined, b: SendStreamChunkResponse | PlainMessage<SendStreamChunkResponse> | undefined): boolean {
    return proto2.util.equals(SendStreamChunkResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamTrailerResponse
 */
export class SendStreamTrailerResponse extends Message<SendStreamTrailerResponse> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  constructor(data?: PartialMessage<SendStreamTrailerResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamTrailerResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamTrailerResponse {
    return new SendStreamTrailerResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamTrailerResponse {
    return new SendStreamTrailerResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamTrailerResponse {
    return new SendStreamTrailerResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamTrailerResponse | PlainMessage<SendStreamTrailerResponse> | undefined, b: SendStreamTrailerResponse | PlainMessage<SendStreamTrailerResponse> | undefined): boolean {
    return proto2.util.equals(SendStreamTrailerResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamHeaderCallback
 */
export class SendStreamHeaderCallback extends Message<SendStreamHeaderCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SendStreamHeaderCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamHeaderCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamHeaderCallback {
    return new SendStreamHeaderCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamHeaderCallback {
    return new SendStreamHeaderCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamHeaderCallback {
    return new SendStreamHeaderCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamHeaderCallback | PlainMessage<SendStreamHeaderCallback> | undefined, b: SendStreamHeaderCallback | PlainMessage<SendStreamHeaderCallback> | undefined): boolean {
    return proto2.util.equals(SendStreamHeaderCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamChunkCallback
 */
export class SendStreamChunkCallback extends Message<SendStreamChunkCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SendStreamChunkCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamChunkCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamChunkCallback {
    return new SendStreamChunkCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamChunkCallback {
    return new SendStreamChunkCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamChunkCallback {
    return new SendStreamChunkCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamChunkCallback | PlainMessage<SendStreamChunkCallback> | undefined, b: SendStreamChunkCallback | PlainMessage<SendStreamChunkCallback> | undefined): boolean {
    return proto2.util.equals(SendStreamChunkCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.SendStreamTrailerCallback
 */
export class SendStreamTrailerCallback extends Message<SendStreamTrailerCallback> {
  /**
   * @generated from field: required uint64 async_id = 1;
   */
  asyncId?: bigint;

  /**
   * @generated from field: optional string error = 2;
   */
  error?: string;

  constructor(data?: PartialMessage<SendStreamTrailerCallback>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SendStreamTrailerCallback";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "async_id", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SendStreamTrailerCallback {
    return new SendStreamTrailerCallback().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SendStreamTrailerCallback {
    return new SendStreamTrailerCallback().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SendStreamTrailerCallback {
    return new SendStreamTrailerCallback().fromJsonString(jsonString, options);
  }

  static equals(a: SendStreamTrailerCallback | PlainMessage<SendStreamTrailerCallback> | undefined, b: SendStreamTrailerCallback | PlainMessage<SendStreamTrailerCallback> | undefined): boolean {
    return proto2.util.equals(SendStreamTrailerCallback, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetDataChannelBufferedAmountLowThresholdRequest
 */
export class SetDataChannelBufferedAmountLowThresholdRequest extends Message<SetDataChannelBufferedAmountLowThresholdRequest> {
  /**
   * @generated from field: required uint64 local_participant_handle = 1;
   */
  localParticipantHandle?: bigint;

  /**
   * @generated from field: required uint64 threshold = 2;
   */
  threshold?: bigint;

  /**
   * @generated from field: required livekit.proto.DataPacketKind kind = 3;
   */
  kind?: DataPacketKind;

  constructor(data?: PartialMessage<SetDataChannelBufferedAmountLowThresholdRequest>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetDataChannelBufferedAmountLowThresholdRequest";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "local_participant_handle", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 2, name: "threshold", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
    { no: 3, name: "kind", kind: "enum", T: proto2.getEnumType(DataPacketKind), req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetDataChannelBufferedAmountLowThresholdRequest {
    return new SetDataChannelBufferedAmountLowThresholdRequest().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetDataChannelBufferedAmountLowThresholdRequest {
    return new SetDataChannelBufferedAmountLowThresholdRequest().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetDataChannelBufferedAmountLowThresholdRequest {
    return new SetDataChannelBufferedAmountLowThresholdRequest().fromJsonString(jsonString, options);
  }

  static equals(a: SetDataChannelBufferedAmountLowThresholdRequest | PlainMessage<SetDataChannelBufferedAmountLowThresholdRequest> | undefined, b: SetDataChannelBufferedAmountLowThresholdRequest | PlainMessage<SetDataChannelBufferedAmountLowThresholdRequest> | undefined): boolean {
    return proto2.util.equals(SetDataChannelBufferedAmountLowThresholdRequest, a, b);
  }
}

/**
 * @generated from message livekit.proto.SetDataChannelBufferedAmountLowThresholdResponse
 */
export class SetDataChannelBufferedAmountLowThresholdResponse extends Message<SetDataChannelBufferedAmountLowThresholdResponse> {
  constructor(data?: PartialMessage<SetDataChannelBufferedAmountLowThresholdResponse>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.SetDataChannelBufferedAmountLowThresholdResponse";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): SetDataChannelBufferedAmountLowThresholdResponse {
    return new SetDataChannelBufferedAmountLowThresholdResponse().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): SetDataChannelBufferedAmountLowThresholdResponse {
    return new SetDataChannelBufferedAmountLowThresholdResponse().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): SetDataChannelBufferedAmountLowThresholdResponse {
    return new SetDataChannelBufferedAmountLowThresholdResponse().fromJsonString(jsonString, options);
  }

  static equals(a: SetDataChannelBufferedAmountLowThresholdResponse | PlainMessage<SetDataChannelBufferedAmountLowThresholdResponse> | undefined, b: SetDataChannelBufferedAmountLowThresholdResponse | PlainMessage<SetDataChannelBufferedAmountLowThresholdResponse> | undefined): boolean {
    return proto2.util.equals(SetDataChannelBufferedAmountLowThresholdResponse, a, b);
  }
}

/**
 * @generated from message livekit.proto.DataChannelBufferedAmountLowThresholdChanged
 */
export class DataChannelBufferedAmountLowThresholdChanged extends Message<DataChannelBufferedAmountLowThresholdChanged> {
  /**
   * @generated from field: required livekit.proto.DataPacketKind kind = 1;
   */
  kind?: DataPacketKind;

  /**
   * @generated from field: required uint64 threshold = 2;
   */
  threshold?: bigint;

  constructor(data?: PartialMessage<DataChannelBufferedAmountLowThresholdChanged>) {
    super();
    proto2.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto2 = proto2;
  static readonly typeName = "livekit.proto.DataChannelBufferedAmountLowThresholdChanged";
  static readonly fields: FieldList = proto2.util.newFieldList(() => [
    { no: 1, name: "kind", kind: "enum", T: proto2.getEnumType(DataPacketKind), req: true },
    { no: 2, name: "threshold", kind: "scalar", T: 4 /* ScalarType.UINT64 */, req: true },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): DataChannelBufferedAmountLowThresholdChanged {
    return new DataChannelBufferedAmountLowThresholdChanged().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): DataChannelBufferedAmountLowThresholdChanged {
    return new DataChannelBufferedAmountLowThresholdChanged().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): DataChannelBufferedAmountLowThresholdChanged {
    return new DataChannelBufferedAmountLowThresholdChanged().fromJsonString(jsonString, options);
  }

  static equals(a: DataChannelBufferedAmountLowThresholdChanged | PlainMessage<DataChannelBufferedAmountLowThresholdChanged> | undefined, b: DataChannelBufferedAmountLowThresholdChanged | PlainMessage<DataChannelBufferedAmountLowThresholdChanged> | undefined): boolean {
    return proto2.util.equals(DataChannelBufferedAmountLowThresholdChanged, a, b);
  }
}

